<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Sun, 21 Aug 2011 18:31:51 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_Attachment_Data extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value-class NSData
     * @allows-null 1
     */
    public $content = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 0
     * @width 32
     */
    public $contentHash = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $contentText = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("attachmentDataID");
        $entityConfiguration->setName("attachment-data");
    }

    /**
     * Set content.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Attachment_Data
     */
    public function setContent($value)
    {
        $this->content = $value;
        return $this;
    }

    /**
     * Get content.
     *
     * @return string
     */
    public function getContent()
    {
        return $this->content;
    }

    /**
     * Set contentHash.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_Attachment_Data
     */
    public function setContentHash($value)
    {
        $this->contentHash = $value;
        return $this;
    }

    /**
     * Get contentHash.
     *
     * @return string
     */
    public function getContentHash()
    {
        return $this->contentHash;
    }

    /**
     * Set contentText.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Attachment_Data
     */
    public function setContentText($value)
    {
        $this->contentText = $value;
        return $this;
    }

    /**
     * Get contentText.
     *
     * @return string
     */
    public function getContentText()
    {
        return $this->contentText;
    }


}