<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Sun, 21 Aug 2011 18:31:52 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_Company extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 100
     */
    public $url = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $visitStreet = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $visitCity = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $companyID = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 60
     */
    public $emailAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $name = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 30
     */
    public $visitPostalCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $creationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $visitNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $mailingCity = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $mailingNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 30
     */
    public $mailingPostalCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $mailingStreet = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $deleted = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $visitNumberSuffix = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     */
    public $shortName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $mailingNumberSuffix = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $phoneNumber = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isSupplier = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $creditUntilDate = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $creditLimit = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $lastContactDate = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $invoiceDiscountPercentage = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $gAccountKey = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $gAccountPercentage = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $taxChargeKey = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $creditRestrictPercentage = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $visitFullAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $mailingFullAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $division = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $sourceInfo = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isCompetitor = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $paymentCode = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $companySize = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 12
     */
    public $debtorNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $faxNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $invoiceCity = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $invoiceFullAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $invoiceNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $invoiceNumberSuffix = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 30
     */
    public $invoicePostalCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $invoiceStreet = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 15
     */
    public $kvkNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $nameAlias1 = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $nameAlias2 = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $nameAlias3 = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $notes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $paymentTerm = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $revenue = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $companyInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $taxNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $bankAccountNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 60
     */
    public $bankName = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $creditFromDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $numberOfInvoicePrints = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_DataType_NSDictionary|array
     * @value-class NSDictionary
     * @allows-null 1
     */
    public $invoiceSettings = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $contactCount = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $correspondenceName = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toMainUser
     */
    public $toMainUser = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_User_Company")
     * @mandatory 0
     * @destination-entity CRUserCompany
     * @to-many 1
     * @name userCompanies
     */
    public $userCompanies = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name createdBy
     */
    public $createdBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name modifiedBy
     */
    public $modifiedBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name financialContact
     */
    public $financialContact = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Attachment")
     * @mandatory 0
     * @destination-entity CRAttachment
     * @to-many 1
     * @name attachments
     */
    public $attachments = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toVisitProvinceNode
     * @qualifier ((typeID = 10) or (typeID = 0))
     * @default 1
     * @nodeType Regio
     */
    public $toVisitProvinceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toBrancheLevel1
     * @qualifier ((typeID = 38) or (typeID = 0))
     * @default 1
     * @nodeType Branche0
     */
    public $toBrancheLevel1 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toBrancheLevel2
     * @qualifier ((typeID = 39) or (typeID = 0))
     * @default 1
     * @nodeType Branche1
     */
    public $toBrancheLevel2 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toKeyAccountNode
     * @qualifier ((typeID = 56) or (typeID = 0))
     * @default 1
     * @nodeType Key-account
     */
    public $toKeyAccountNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toVisitCountryNode
     * @qualifier ((typeID = 11) or (typeID = 0))
     * @default 1
     * @nodeType Land
     */
    public $toVisitCountryNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 1
     * @name children
     */
    public $children = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 1
     * @name parents
     */
    public $parents = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Company_Status")
     * @mandatory 0
     * @destination-entity CRCompanyStatus
     * @to-many 1
     * @name statuses
     */
    public $statuses = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name parent
     */
    public $parent = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toBikNode1
     * @qualifier ((typeID = 58) or (typeID = 0))
     * @default
     * @nodeType BIK
     */
    public $toBikNode1 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toBikNode2
     * @qualifier ((typeID = 58) or (typeID = 0))
     * @default
     * @nodeType BIK
     */
    public $toBikNode2 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toMailingCountryNode
     * @qualifier ((typeID = 11) or (typeID = 0))
     * @default
     * @nodeType Land
     */
    public $toMailingCountryNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toMailingProvinceNode
     * @qualifier ((typeID = 10) or (typeID = 0))
     * @default
     * @nodeType Regio
     */
    public $toMailingProvinceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceCollectionNode
     * @qualifier ((typeID = 79) or (typeID = 0))
     * @default 1
     * @nodeType Verzamelfacturen
     */
    public $toInvoiceCollectionNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCreditStatusNode
     * @qualifier ((typeID = 60) or (typeID = 0))
     * @default 1
     * @nodeType Krediet-status
     */
    public $toCreditStatusNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toInvoiceCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSourceNode
     * @qualifier ((typeID = 208) or (typeID = 0))
     * @default
     * @nodeType Bron-Opdrachtgever
     */
    public $toSourceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toAccountTypeNode
     * @qualifier ((typeID = 48) or (typeID = 0))
     * @default 1
     * @nodeType Rekeningtype
     */
    public $toAccountTypeNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceCountryNode
     * @qualifier ((typeID = 11) or (typeID = 0))
     * @default
     * @nodeType Land
     */
    public $toInvoiceCountryNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceProvinceNode
     * @qualifier ((typeID = 10) or (typeID = 0))
     * @default
     * @nodeType Regio
     */
    public $toInvoiceProvinceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toRechtsvormNode
     * @qualifier ((typeID = 36) or (typeID = 0))
     * @default 1
     * @nodeType Rechtspersoon
     */
    public $toRechtsvormNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toRevenueCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toRevenueCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Vacancy")
     * @mandatory 0
     * @destination-entity CRVacancy
     * @to-many 1
     * @name vacancies
     */
    public $vacancies = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCreditLimitCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toCreditLimitCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoicePeriodNode
     * @qualifier ((typeID = 63) or (typeID = 0))
     * @default 1
     * @nodeType Facturatieperiode
     */
    public $toInvoicePeriodNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 1
     * @name groupNodes
     */
    public $groupNodes = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toLanguageNode
     * @qualifier ((typeID = 31) or (typeID = 0))
     * @default 1
     * @nodeType Taal
     */
    public $toLanguageNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toKindNode
     * @qualifier ((typeID = 178) or (typeID = 0))
     * @default 1
     * @nodeType Opdrachtgever-soort
     */
    public $toKindNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPaymentPeriodNode
     * @qualifier ((typeID = 62) or (typeID = 0))
     * @default 1
     * @nodeType Betalingstermijn
     */
    public $toPaymentPeriodNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toTaxRateNode
     * @qualifier ((typeID = 189) or (typeID = 0))
     * @default 1
     * @nodeType BTW-tarief
     */
    public $toTaxRateNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toUnionConditions1Node
     */
    public $toUnionConditions1Node = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toUnionConditions2Node
     */
    public $toUnionConditions2Node = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceHandlingNode
     * @qualifier ((typeID = 219) or (typeID = 0))
     * @default 1
     * @nodeType Factuurafhandeling
     */
    public $toInvoiceHandlingNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceLineLabelNode
     * @qualifier ((typeID = 216) or (typeID = 0))
     * @default 1
     * @nodeType Factuurregel-label
     */
    public $toInvoiceLineLabelNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPaymentPeriodStartDateNode
     * @qualifier ((typeID = 217) or (typeID = 0))
     * @default 1
     * @nodeType Betalingstermijn-startdatum
     */
    public $toPaymentPeriodStartDateNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCreditMethodNode
     * @qualifier ((typeID = 218) or (typeID = 0))
     * @default 1
     * @nodeType Crediteringsmethode
     */
    public $toCreditMethodNode = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("companyID");
        $entityConfiguration->setName("company");
    }

    /**
     * Set url.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setUrl($value)
    {
        $this->url = $value;
        return $this;
    }

    /**
     * Get url.
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * Set visitStreet.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setVisitStreet($value)
    {
        $this->visitStreet = $value;
        return $this;
    }

    /**
     * Get visitStreet.
     *
     * @return string
     */
    public function getVisitStreet()
    {
        return $this->visitStreet;
    }

    /**
     * Set visitCity.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setVisitCity($value)
    {
        $this->visitCity = $value;
        return $this;
    }

    /**
     * Get visitCity.
     *
     * @return string
     */
    public function getVisitCity()
    {
        return $this->visitCity;
    }

    /**
     * Set companyID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCompanyID($value)
    {
        $this->companyID = $value;
        return $this;
    }

    /**
     * Get companyID.
     *
     * @return integer
     */
    public function getCompanyID()
    {
        return $this->companyID;
    }

    /**
     * Set emailAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setEmailAddress($value)
    {
        $this->emailAddress = $value;
        return $this;
    }

    /**
     * Get emailAddress.
     *
     * @return string
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }

    /**
     * Set name.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setName($value)
    {
        $this->name = $value;
        return $this;
    }

    /**
     * Get name.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set visitPostalCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setVisitPostalCode($value)
    {
        $this->visitPostalCode = $value;
        return $this;
    }

    /**
     * Get visitPostalCode.
     *
     * @return string
     */
    public function getVisitPostalCode()
    {
        return $this->visitPostalCode;
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set visitNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setVisitNumber($value)
    {
        $this->visitNumber = $value;
        return $this;
    }

    /**
     * Get visitNumber.
     *
     * @return string
     */
    public function getVisitNumber()
    {
        return $this->visitNumber;
    }

    /**
     * Set mailingCity.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setMailingCity($value)
    {
        $this->mailingCity = $value;
        return $this;
    }

    /**
     * Get mailingCity.
     *
     * @return string
     */
    public function getMailingCity()
    {
        return $this->mailingCity;
    }

    /**
     * Set mailingNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setMailingNumber($value)
    {
        $this->mailingNumber = $value;
        return $this;
    }

    /**
     * Get mailingNumber.
     *
     * @return string
     */
    public function getMailingNumber()
    {
        return $this->mailingNumber;
    }

    /**
     * Set mailingPostalCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setMailingPostalCode($value)
    {
        $this->mailingPostalCode = $value;
        return $this;
    }

    /**
     * Get mailingPostalCode.
     *
     * @return string
     */
    public function getMailingPostalCode()
    {
        return $this->mailingPostalCode;
    }

    /**
     * Set mailingStreet.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setMailingStreet($value)
    {
        $this->mailingStreet = $value;
        return $this;
    }

    /**
     * Get mailingStreet.
     *
     * @return string
     */
    public function getMailingStreet()
    {
        return $this->mailingStreet;
    }

    /**
     * Set deleted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setDeleted($value)
    {
        $this->deleted = $value;
        return $this;
    }

    /**
     * Get deleted.
     *
     * @return integer
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set visitNumberSuffix.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setVisitNumberSuffix($value)
    {
        $this->visitNumberSuffix = $value;
        return $this;
    }

    /**
     * Get visitNumberSuffix.
     *
     * @return string
     */
    public function getVisitNumberSuffix()
    {
        return $this->visitNumberSuffix;
    }

    /**
     * Set shortName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setShortName($value)
    {
        $this->shortName = $value;
        return $this;
    }

    /**
     * Get shortName.
     *
     * @return string
     */
    public function getShortName()
    {
        return $this->shortName;
    }

    /**
     * Set mailingNumberSuffix.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setMailingNumberSuffix($value)
    {
        $this->mailingNumberSuffix = $value;
        return $this;
    }

    /**
     * Get mailingNumberSuffix.
     *
     * @return string
     */
    public function getMailingNumberSuffix()
    {
        return $this->mailingNumberSuffix;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set phoneNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setPhoneNumber($value)
    {
        $this->phoneNumber = $value;
        return $this;
    }

    /**
     * Get phoneNumber.
     *
     * @return string
     */
    public function getPhoneNumber()
    {
        return $this->phoneNumber;
    }

    /**
     * Set isSupplier.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setIsSupplier($value)
    {
        $this->isSupplier = $value;
        return $this;
    }

    /**
     * Get isSupplier.
     *
     * @return integer
     */
    public function getIsSupplier()
    {
        return $this->isSupplier;
    }

    /**
     * Set creditUntilDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCreditUntilDate($value)
    {
        $this->creditUntilDate = $value;
        return $this;
    }

    /**
     * Get creditUntilDate.
     *
     * @return string
     */
    public function getCreditUntilDate()
    {
        return $this->creditUntilDate;
    }

    /**
     * Set creditLimit.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCreditLimit($value)
    {
        $this->creditLimit = $value;
        return $this;
    }

    /**
     * Get creditLimit.
     *
     * @return float
     */
    public function getCreditLimit()
    {
        return $this->creditLimit;
    }

    /**
     * Set lastContactDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setLastContactDate($value)
    {
        $this->lastContactDate = $value;
        return $this;
    }

    /**
     * Get lastContactDate.
     *
     * @return string
     */
    public function getLastContactDate()
    {
        return $this->lastContactDate;
    }

    /**
     * Set invoiceDiscountPercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setInvoiceDiscountPercentage($value)
    {
        $this->invoiceDiscountPercentage = $value;
        return $this;
    }

    /**
     * Get invoiceDiscountPercentage.
     *
     * @return float
     */
    public function getInvoiceDiscountPercentage()
    {
        return $this->invoiceDiscountPercentage;
    }

    /**
     * Set gAccountKey.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setGAccountKey($value)
    {
        $this->gAccountKey = $value;
        return $this;
    }

    /**
     * Get gAccountKey.
     *
     * @return integer
     */
    public function getGAccountKey()
    {
        return $this->gAccountKey;
    }

    /**
     * Set gAccountPercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setGAccountPercentage($value)
    {
        $this->gAccountPercentage = $value;
        return $this;
    }

    /**
     * Get gAccountPercentage.
     *
     * @return float
     */
    public function getGAccountPercentage()
    {
        return $this->gAccountPercentage;
    }

    /**
     * Set taxChargeKey.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setTaxChargeKey($value)
    {
        $this->taxChargeKey = $value;
        return $this;
    }

    /**
     * Get taxChargeKey.
     *
     * @return integer
     */
    public function getTaxChargeKey()
    {
        return $this->taxChargeKey;
    }

    /**
     * Set creditRestrictPercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCreditRestrictPercentage($value)
    {
        $this->creditRestrictPercentage = $value;
        return $this;
    }

    /**
     * Get creditRestrictPercentage.
     *
     * @return float
     */
    public function getCreditRestrictPercentage()
    {
        return $this->creditRestrictPercentage;
    }

    /**
     * Set visitFullAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setVisitFullAddress($value)
    {
        $this->visitFullAddress = $value;
        return $this;
    }

    /**
     * Get visitFullAddress.
     *
     * @return string
     */
    public function getVisitFullAddress()
    {
        return $this->visitFullAddress;
    }

    /**
     * Set mailingFullAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setMailingFullAddress($value)
    {
        $this->mailingFullAddress = $value;
        return $this;
    }

    /**
     * Get mailingFullAddress.
     *
     * @return string
     */
    public function getMailingFullAddress()
    {
        return $this->mailingFullAddress;
    }

    /**
     * Set division.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setDivision($value)
    {
        $this->division = $value;
        return $this;
    }

    /**
     * Get division.
     *
     * @return string
     */
    public function getDivision()
    {
        return $this->division;
    }

    /**
     * Set sourceInfo.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setSourceInfo($value)
    {
        $this->sourceInfo = $value;
        return $this;
    }

    /**
     * Get sourceInfo.
     *
     * @return string
     */
    public function getSourceInfo()
    {
        return $this->sourceInfo;
    }

    /**
     * Set isCompetitor.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setIsCompetitor($value)
    {
        $this->isCompetitor = $value;
        return $this;
    }

    /**
     * Get isCompetitor.
     *
     * @return integer
     */
    public function getIsCompetitor()
    {
        return $this->isCompetitor;
    }

    /**
     * Set paymentCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setPaymentCode($value)
    {
        $this->paymentCode = $value;
        return $this;
    }

    /**
     * Get paymentCode.
     *
     * @return string
     */
    public function getPaymentCode()
    {
        return $this->paymentCode;
    }

    /**
     * Set companySize.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCompanySize($value)
    {
        $this->companySize = $value;
        return $this;
    }

    /**
     * Get companySize.
     *
     * @return integer
     */
    public function getCompanySize()
    {
        return $this->companySize;
    }

    /**
     * Set debtorNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setDebtorNumber($value)
    {
        $this->debtorNumber = $value;
        return $this;
    }

    /**
     * Get debtorNumber.
     *
     * @return string
     */
    public function getDebtorNumber()
    {
        return $this->debtorNumber;
    }

    /**
     * Set faxNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setFaxNumber($value)
    {
        $this->faxNumber = $value;
        return $this;
    }

    /**
     * Get faxNumber.
     *
     * @return string
     */
    public function getFaxNumber()
    {
        return $this->faxNumber;
    }

    /**
     * Set invoiceCity.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setInvoiceCity($value)
    {
        $this->invoiceCity = $value;
        return $this;
    }

    /**
     * Get invoiceCity.
     *
     * @return string
     */
    public function getInvoiceCity()
    {
        return $this->invoiceCity;
    }

    /**
     * Set invoiceFullAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setInvoiceFullAddress($value)
    {
        $this->invoiceFullAddress = $value;
        return $this;
    }

    /**
     * Get invoiceFullAddress.
     *
     * @return string
     */
    public function getInvoiceFullAddress()
    {
        return $this->invoiceFullAddress;
    }

    /**
     * Set invoiceNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setInvoiceNumber($value)
    {
        $this->invoiceNumber = $value;
        return $this;
    }

    /**
     * Get invoiceNumber.
     *
     * @return string
     */
    public function getInvoiceNumber()
    {
        return $this->invoiceNumber;
    }

    /**
     * Set invoiceNumberSuffix.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setInvoiceNumberSuffix($value)
    {
        $this->invoiceNumberSuffix = $value;
        return $this;
    }

    /**
     * Get invoiceNumberSuffix.
     *
     * @return string
     */
    public function getInvoiceNumberSuffix()
    {
        return $this->invoiceNumberSuffix;
    }

    /**
     * Set invoicePostalCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setInvoicePostalCode($value)
    {
        $this->invoicePostalCode = $value;
        return $this;
    }

    /**
     * Get invoicePostalCode.
     *
     * @return string
     */
    public function getInvoicePostalCode()
    {
        return $this->invoicePostalCode;
    }

    /**
     * Set invoiceStreet.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setInvoiceStreet($value)
    {
        $this->invoiceStreet = $value;
        return $this;
    }

    /**
     * Get invoiceStreet.
     *
     * @return string
     */
    public function getInvoiceStreet()
    {
        return $this->invoiceStreet;
    }

    /**
     * Set kvkNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setKvkNumber($value)
    {
        $this->kvkNumber = $value;
        return $this;
    }

    /**
     * Get kvkNumber.
     *
     * @return string
     */
    public function getKvkNumber()
    {
        return $this->kvkNumber;
    }

    /**
     * Set nameAlias1.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setNameAlias1($value)
    {
        $this->nameAlias1 = $value;
        return $this;
    }

    /**
     * Get nameAlias1.
     *
     * @return string
     */
    public function getNameAlias1()
    {
        return $this->nameAlias1;
    }

    /**
     * Set nameAlias2.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setNameAlias2($value)
    {
        $this->nameAlias2 = $value;
        return $this;
    }

    /**
     * Get nameAlias2.
     *
     * @return string
     */
    public function getNameAlias2()
    {
        return $this->nameAlias2;
    }

    /**
     * Set nameAlias3.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setNameAlias3($value)
    {
        $this->nameAlias3 = $value;
        return $this;
    }

    /**
     * Get nameAlias3.
     *
     * @return string
     */
    public function getNameAlias3()
    {
        return $this->nameAlias3;
    }

    /**
     * Set notes.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setNotes($value)
    {
        $this->notes = $value;
        return $this;
    }

    /**
     * Get notes.
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set paymentTerm.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setPaymentTerm($value)
    {
        $this->paymentTerm = $value;
        return $this;
    }

    /**
     * Get paymentTerm.
     *
     * @return integer
     */
    public function getPaymentTerm()
    {
        return $this->paymentTerm;
    }

    /**
     * Set revenue.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setRevenue($value)
    {
        $this->revenue = $value;
        return $this;
    }

    /**
     * Get revenue.
     *
     * @return float
     */
    public function getRevenue()
    {
        return $this->revenue;
    }

    /**
     * Set companyInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCompanyInformation($value)
    {
        $this->companyInformation = $value;
        return $this;
    }

    /**
     * Get companyInformation.
     *
     * @return string
     */
    public function getCompanyInformation()
    {
        return $this->companyInformation;
    }

    /**
     * Set taxNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setTaxNumber($value)
    {
        $this->taxNumber = $value;
        return $this;
    }

    /**
     * Get taxNumber.
     *
     * @return string
     */
    public function getTaxNumber()
    {
        return $this->taxNumber;
    }

    /**
     * Set bankAccountNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setBankAccountNumber($value)
    {
        $this->bankAccountNumber = $value;
        return $this;
    }

    /**
     * Get bankAccountNumber.
     *
     * @return string
     */
    public function getBankAccountNumber()
    {
        return $this->bankAccountNumber;
    }

    /**
     * Set bankName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setBankName($value)
    {
        $this->bankName = $value;
        return $this;
    }

    /**
     * Get bankName.
     *
     * @return string
     */
    public function getBankName()
    {
        return $this->bankName;
    }

    /**
     * Set creditFromDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCreditFromDate($value)
    {
        $this->creditFromDate = $value;
        return $this;
    }

    /**
     * Get creditFromDate.
     *
     * @return string
     */
    public function getCreditFromDate()
    {
        return $this->creditFromDate;
    }

    /**
     * Set numberOfInvoicePrints.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setNumberOfInvoicePrints($value)
    {
        $this->numberOfInvoicePrints = $value;
        return $this;
    }

    /**
     * Get numberOfInvoicePrints.
     *
     * @return integer
     */
    public function getNumberOfInvoicePrints()
    {
        return $this->numberOfInvoicePrints;
    }

    /**
     * Set invoiceSettings.
     *
     * Provides a fluent interface.
     *
     * @param Carerix_Api_Rest_DataType_NSDictionary|array $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setInvoiceSettings($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_DataType_NSDictionary($value);
        }
        $this->invoiceSettings = $value;
        return $this;
    }

    /**
     * Get invoiceSettings.
     *
     * @return Carerix_Api_Rest_DataType_NSDictionary|array
     */
    public function getInvoiceSettings()
    {
        return $this->invoiceSettings;
    }

    /**
     * Set contactCount.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setContactCount($value)
    {
        $this->contactCount = $value;
        return $this;
    }

    /**
     * Get contactCount.
     *
     * @return integer
     */
    public function getContactCount()
    {
        return $this->contactCount;
    }

    /**
     * Set correspondenceName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCorrespondenceName($value)
    {
        $this->correspondenceName = $value;
        return $this;
    }

    /**
     * Get correspondenceName.
     *
     * @return string
     */
    public function getCorrespondenceName()
    {
        return $this->correspondenceName;
    }

    /**
     * Set toMainUser.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToMainUser($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toMainUser = $value;
        return $this;
    }

    /**
     * Get toMainUser.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToMainUser()
    {
        return $this->toMainUser;
    }

    /**
     * Set userCompanies.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setUserCompanies($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->userCompanies = $values;
        return $this;
    }

    /**
     * Get userCompanies.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_User_Company
     */
    public function getUserCompanies($index = null)
    {
        if($index !== null) {
            return $this->userCompanies[$index];
        }
        return $this->userCompanies;
    }

    /**
     * Set createdBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setCreatedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->createdBy = $value;
        return $this;
    }

    /**
     * Get createdBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set modifiedBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setModifiedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->modifiedBy = $value;
        return $this;
    }

    /**
     * Get modifiedBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getModifiedBy()
    {
        return $this->modifiedBy;
    }

    /**
     * Set financialContact.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setFinancialContact($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->financialContact = $value;
        return $this;
    }

    /**
     * Get financialContact.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getFinancialContact()
    {
        return $this->financialContact;
    }

    /**
     * Set attachments.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setAttachments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->attachments = $values;
        return $this;
    }

    /**
     * Get attachments.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Attachment
     */
    public function getAttachments($index = null)
    {
        if($index !== null) {
            return $this->attachments[$index];
        }
        return $this->attachments;
    }

    /**
     * Set toVisitProvinceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToVisitProvinceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toVisitProvinceNode = $value;
        return $this;
    }

    /**
     * Get toVisitProvinceNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToVisitProvinceNode()
    {
        return $this->toVisitProvinceNode;
    }

    /**
     * Set toBrancheLevel1.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToBrancheLevel1($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toBrancheLevel1 = $value;
        return $this;
    }

    /**
     * Get toBrancheLevel1.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToBrancheLevel1()
    {
        return $this->toBrancheLevel1;
    }

    /**
     * Set toBrancheLevel2.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToBrancheLevel2($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toBrancheLevel2 = $value;
        return $this;
    }

    /**
     * Get toBrancheLevel2.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToBrancheLevel2()
    {
        return $this->toBrancheLevel2;
    }

    /**
     * Set toKeyAccountNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToKeyAccountNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toKeyAccountNode = $value;
        return $this;
    }

    /**
     * Get toKeyAccountNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToKeyAccountNode()
    {
        return $this->toKeyAccountNode;
    }

    /**
     * Set toVisitCountryNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToVisitCountryNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toVisitCountryNode = $value;
        return $this;
    }

    /**
     * Get toVisitCountryNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToVisitCountryNode()
    {
        return $this->toVisitCountryNode;
    }

    /**
     * Set children.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setChildren($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->children = $values;
        return $this;
    }

    /**
     * Get children.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Company
     */
    public function getChildren($index = null)
    {
        if($index !== null) {
            return $this->children[$index];
        }
        return $this->children;
    }

    /**
     * Set parents.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setParents($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->parents = $values;
        return $this;
    }

    /**
     * Get parents.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Company
     */
    public function getParents($index = null)
    {
        if($index !== null) {
            return $this->parents[$index];
        }
        return $this->parents;
    }

    /**
     * Set statuses.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setStatuses($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->statuses = $values;
        return $this;
    }

    /**
     * Get statuses.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Company_Status
     */
    public function getStatuses($index = null)
    {
        if($index !== null) {
            return $this->statuses[$index];
        }
        return $this->statuses;
    }

    /**
     * Set parent.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setParent($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->parent = $value;
        return $this;
    }

    /**
     * Get parent.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Set toBikNode1.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToBikNode1($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toBikNode1 = $value;
        return $this;
    }

    /**
     * Get toBikNode1.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToBikNode1()
    {
        return $this->toBikNode1;
    }

    /**
     * Set toBikNode2.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToBikNode2($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toBikNode2 = $value;
        return $this;
    }

    /**
     * Get toBikNode2.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToBikNode2()
    {
        return $this->toBikNode2;
    }

    /**
     * Set toMailingCountryNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToMailingCountryNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toMailingCountryNode = $value;
        return $this;
    }

    /**
     * Get toMailingCountryNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToMailingCountryNode()
    {
        return $this->toMailingCountryNode;
    }

    /**
     * Set toMailingProvinceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToMailingProvinceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toMailingProvinceNode = $value;
        return $this;
    }

    /**
     * Get toMailingProvinceNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToMailingProvinceNode()
    {
        return $this->toMailingProvinceNode;
    }

    /**
     * Set toInvoiceCollectionNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToInvoiceCollectionNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceCollectionNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceCollectionNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceCollectionNode()
    {
        return $this->toInvoiceCollectionNode;
    }

    /**
     * Set toCreditStatusNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToCreditStatusNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCreditStatusNode = $value;
        return $this;
    }

    /**
     * Get toCreditStatusNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCreditStatusNode()
    {
        return $this->toCreditStatusNode;
    }

    /**
     * Set toInvoiceCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToInvoiceCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceCurrencyNode()
    {
        return $this->toInvoiceCurrencyNode;
    }

    /**
     * Set toSourceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToSourceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSourceNode = $value;
        return $this;
    }

    /**
     * Get toSourceNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSourceNode()
    {
        return $this->toSourceNode;
    }

    /**
     * Set toAccountTypeNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToAccountTypeNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toAccountTypeNode = $value;
        return $this;
    }

    /**
     * Get toAccountTypeNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToAccountTypeNode()
    {
        return $this->toAccountTypeNode;
    }

    /**
     * Set toInvoiceCountryNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToInvoiceCountryNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceCountryNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceCountryNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceCountryNode()
    {
        return $this->toInvoiceCountryNode;
    }

    /**
     * Set toInvoiceProvinceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToInvoiceProvinceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceProvinceNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceProvinceNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceProvinceNode()
    {
        return $this->toInvoiceProvinceNode;
    }

    /**
     * Set toRechtsvormNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToRechtsvormNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toRechtsvormNode = $value;
        return $this;
    }

    /**
     * Get toRechtsvormNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToRechtsvormNode()
    {
        return $this->toRechtsvormNode;
    }

    /**
     * Set toRevenueCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToRevenueCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toRevenueCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toRevenueCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToRevenueCurrencyNode()
    {
        return $this->toRevenueCurrencyNode;
    }

    /**
     * Set vacancies.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setVacancies($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->vacancies = $values;
        return $this;
    }

    /**
     * Get vacancies.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Vacancy
     */
    public function getVacancies($index = null)
    {
        if($index !== null) {
            return $this->vacancies[$index];
        }
        return $this->vacancies;
    }

    /**
     * Set toCreditLimitCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToCreditLimitCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCreditLimitCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toCreditLimitCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCreditLimitCurrencyNode()
    {
        return $this->toCreditLimitCurrencyNode;
    }

    /**
     * Set toInvoicePeriodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToInvoicePeriodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoicePeriodNode = $value;
        return $this;
    }

    /**
     * Get toInvoicePeriodNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoicePeriodNode()
    {
        return $this->toInvoicePeriodNode;
    }

    /**
     * Set groupNodes.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setGroupNodes($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->groupNodes = $values;
        return $this;
    }

    /**
     * Get groupNodes.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Data_Node
     */
    public function getGroupNodes($index = null)
    {
        if($index !== null) {
            return $this->groupNodes[$index];
        }
        return $this->groupNodes;
    }

    /**
     * Set toLanguageNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToLanguageNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toLanguageNode = $value;
        return $this;
    }

    /**
     * Get toLanguageNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToLanguageNode()
    {
        return $this->toLanguageNode;
    }

    /**
     * Set toKindNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToKindNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toKindNode = $value;
        return $this;
    }

    /**
     * Get toKindNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToKindNode()
    {
        return $this->toKindNode;
    }

    /**
     * Set toPaymentPeriodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToPaymentPeriodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPaymentPeriodNode = $value;
        return $this;
    }

    /**
     * Get toPaymentPeriodNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPaymentPeriodNode()
    {
        return $this->toPaymentPeriodNode;
    }

    /**
     * Set toTaxRateNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToTaxRateNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toTaxRateNode = $value;
        return $this;
    }

    /**
     * Get toTaxRateNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToTaxRateNode()
    {
        return $this->toTaxRateNode;
    }

    /**
     * Set toUnionConditions1Node.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToUnionConditions1Node($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toUnionConditions1Node = $value;
        return $this;
    }

    /**
     * Get toUnionConditions1Node.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToUnionConditions1Node()
    {
        return $this->toUnionConditions1Node;
    }

    /**
     * Set toUnionConditions2Node.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToUnionConditions2Node($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toUnionConditions2Node = $value;
        return $this;
    }

    /**
     * Get toUnionConditions2Node.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToUnionConditions2Node()
    {
        return $this->toUnionConditions2Node;
    }

    /**
     * Set toInvoiceHandlingNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToInvoiceHandlingNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceHandlingNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceHandlingNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceHandlingNode()
    {
        return $this->toInvoiceHandlingNode;
    }

    /**
     * Set toInvoiceLineLabelNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToInvoiceLineLabelNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceLineLabelNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceLineLabelNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceLineLabelNode()
    {
        return $this->toInvoiceLineLabelNode;
    }

    /**
     * Set toPaymentPeriodStartDateNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToPaymentPeriodStartDateNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPaymentPeriodStartDateNode = $value;
        return $this;
    }

    /**
     * Get toPaymentPeriodStartDateNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPaymentPeriodStartDateNode()
    {
        return $this->toPaymentPeriodStartDateNode;
    }

    /**
     * Set toCreditMethodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Company
     */
    public function setToCreditMethodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCreditMethodNode = $value;
        return $this;
    }

    /**
     * Get toCreditMethodNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCreditMethodNode()
    {
        return $this->toCreditMethodNode;
    }


}