<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Sun, 21 Aug 2011 18:32:04 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_Job extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $creationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $endDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $startDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $deleted = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $hoursPerWeek = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $daysPerWeek = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $hourlyWageGross = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $hourlyTariffExtra = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $hourlyTariffInvoice = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $jobID = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $_flags = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 5
     */
    public $startTime = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $memoGeneral = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $memoDeclaration = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $memoWeekLog = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $invoiceSubject = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $noticePeriodDays = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $signatureRequired = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $hourlyWageStandBy = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $templateName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $hourlyTariffExtraNotes = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $pgcHours = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $rotationOff = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $rotationOn = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $lastTrialDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $status = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $friWorkMinutes = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $jobInformation = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $monWorkMinutes = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $phoneNumber = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $satWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $sunWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $thuWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $tueWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $wedWorkMinutes = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     */
    public $externalIdentifier = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $forecastDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $invoiceDiscountPercentage = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $customerReference = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isTemplate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width
     */
    public $name = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $costPrice = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $sellingPrice = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Employee
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Employee")
     * @mandatory 0
     * @destination-entity CREmployee
     * @to-many 0
     * @name toEmployee
     */
    public $toEmployee = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Vacancy
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Vacancy")
     * @mandatory 0
     * @destination-entity CRVacancy
     * @to-many 0
     * @name toVacancy
     */
    public $toVacancy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Week_Hour")
     * @mandatory 0
     * @destination-entity CRWeekHour
     * @to-many 1
     * @name allWeekHours
     */
    public $allWeekHours = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name owner
     */
    public $owner = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Match
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Match")
     * @mandatory 0
     * @destination-entity CRMatch
     * @to-many 0
     * @name toMatch
     */
    public $toMatch = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Attachment")
     * @mandatory 0
     * @destination-entity CRAttachment
     * @to-many 1
     * @name attachments
     */
    public $attachments = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toContractTypeNode
     * @qualifier ((typeID = 61) or (typeID = 0))
     * @default 1
     * @nodeType Plaatsing-Contract-type
     */
    public $toContractTypeNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoicePeriodNode
     * @qualifier ((typeID = 63) or (typeID = 0))
     * @default 1
     * @nodeType Facturatieperiode
     */
    public $toInvoicePeriodNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toWorkUnitNode
     * @qualifier ((typeID = 119) or (typeID = 0))
     * @default 1
     * @nodeType Werktijden-eenheid
     */
    public $toWorkUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toRotationOffUnitNode
     * @qualifier ((typeID = 118) or (typeID = 0))
     * @default 1
     * @nodeType Werkschema-eenheid
     */
    public $toRotationOffUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toRotationOnUnitNode
     * @qualifier ((typeID = 118) or (typeID = 0))
     * @default 1
     * @nodeType Werkschema-eenheid
     */
    public $toRotationOnUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPgcHoursUnitNode
     * @qualifier ((typeID = 114) or (typeID = 0))
     * @default 1
     * @nodeType Resturen-eenheid
     */
    public $toPgcHoursUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toNoticeUnitNode
     * @qualifier ((typeID = 112) or (typeID = 0))
     * @default 1
     * @nodeType Opzegtermijn-eenheid
     */
    public $toNoticeUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_To_Do")
     * @mandatory 0
     * @destination-entity CRToDo
     * @to-many 1
     * @name _todos
     * @inverseName toJob
     */
    public $_todos = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toEndReasonNode
     * @qualifier ((typeID = 122) or (typeID = 0))
     * @default
     * @nodeType Plaatsing-reden-beeindiging
     */
    public $toEndReasonNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Finance")
     * @mandatory 0
     * @destination-entity CRFinance
     * @to-many 1
     * @name finances
     */
    public $finances = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Week_Hour_Job_View")
     * @mandatory 0
     * @destination-entity CRWeekHourJobView
     * @to-many 1
     * @name weekHourJobViews
     */
    public $weekHourJobViews = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toStatusNode
     * @qualifier ((typeID = 150) or (typeID = 0))
     * @default 1
     * @nodeType Plaatsing-status
     */
    public $toStatusNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Job_Document")
     * @mandatory 0
     * @destination-entity CRJobDocument
     * @to-many 1
     * @name documents
     */
    public $documents = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toWeekHourCompany
     */
    public $toWeekHourCompany = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Attribute_Change")
     * @mandatory 0
     * @destination-entity CRAttributeChange
     * @to-many 1
     * @name attributeChanges
     * @qualifier (attributeEntityName = 'CRJob')
     */
    public $attributeChanges = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toHoursApprovementNode
     * @qualifier ((typeID = 187) or (typeID = 0))
     * @default
     * @nodeType Plaatsing-goedkeuring-uren
     */
    public $toHoursApprovementNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPaymentPeriodNode
     * @qualifier ((typeID = 62) or (typeID = 0))
     * @default 1
     * @nodeType Betalingstermijn
     */
    public $toPaymentPeriodNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toTaxRateNode
     * @qualifier ((typeID = 189) or (typeID = 0))
     * @default 1
     * @nodeType BTW-tarief
     */
    public $toTaxRateNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Invoice_Line")
     * @mandatory 0
     * @destination-entity CRInvoiceLine
     * @to-many 1
     * @name invoiceLines
     */
    public $invoiceLines = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name createdBy
     */
    public $createdBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name modifiedBy
     */
    public $modifiedBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCostPriceCurrencyNode
     */
    public $toCostPriceCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCostPriceUnitNode
     */
    public $toCostPriceUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSellingPriceCurrencyNode
     */
    public $toSellingPriceCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSellingPriceUnitNode
     */
    public $toSellingPriceUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 1
     * @name groupNodes
     */
    public $groupNodes = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("jobID");
        $entityConfiguration->setName("job");
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set endDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setEndDate($value)
    {
        $this->endDate = $value;
        return $this;
    }

    /**
     * Get endDate.
     *
     * @return string
     */
    public function getEndDate()
    {
        return $this->endDate;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set startDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setStartDate($value)
    {
        $this->startDate = $value;
        return $this;
    }

    /**
     * Get startDate.
     *
     * @return string
     */
    public function getStartDate()
    {
        return $this->startDate;
    }

    /**
     * Set deleted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setDeleted($value)
    {
        $this->deleted = $value;
        return $this;
    }

    /**
     * Get deleted.
     *
     * @return integer
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set hoursPerWeek.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setHoursPerWeek($value)
    {
        $this->hoursPerWeek = $value;
        return $this;
    }

    /**
     * Get hoursPerWeek.
     *
     * @return float
     */
    public function getHoursPerWeek()
    {
        return $this->hoursPerWeek;
    }

    /**
     * Set daysPerWeek.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setDaysPerWeek($value)
    {
        $this->daysPerWeek = $value;
        return $this;
    }

    /**
     * Get daysPerWeek.
     *
     * @return integer
     */
    public function getDaysPerWeek()
    {
        return $this->daysPerWeek;
    }

    /**
     * Set hourlyWageGross.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setHourlyWageGross($value)
    {
        $this->hourlyWageGross = $value;
        return $this;
    }

    /**
     * Get hourlyWageGross.
     *
     * @return float
     */
    public function getHourlyWageGross()
    {
        return $this->hourlyWageGross;
    }

    /**
     * Set hourlyTariffExtra.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setHourlyTariffExtra($value)
    {
        $this->hourlyTariffExtra = $value;
        return $this;
    }

    /**
     * Get hourlyTariffExtra.
     *
     * @return float
     */
    public function getHourlyTariffExtra()
    {
        return $this->hourlyTariffExtra;
    }

    /**
     * Set hourlyTariffInvoice.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setHourlyTariffInvoice($value)
    {
        $this->hourlyTariffInvoice = $value;
        return $this;
    }

    /**
     * Get hourlyTariffInvoice.
     *
     * @return float
     */
    public function getHourlyTariffInvoice()
    {
        return $this->hourlyTariffInvoice;
    }

    /**
     * Set jobID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setJobID($value)
    {
        $this->jobID = $value;
        return $this;
    }

    /**
     * Get jobID.
     *
     * @return integer
     */
    public function getJobID()
    {
        return $this->jobID;
    }

    /**
     * Set _flags.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function set_flags($value)
    {
        $this->_flags = $value;
        return $this;
    }

    /**
     * Get _flags.
     *
     * @return integer
     */
    public function get_flags()
    {
        return $this->_flags;
    }

    /**
     * Set startTime.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setStartTime($value)
    {
        $this->startTime = $value;
        return $this;
    }

    /**
     * Get startTime.
     *
     * @return string
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * Set memoGeneral.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setMemoGeneral($value)
    {
        $this->memoGeneral = $value;
        return $this;
    }

    /**
     * Get memoGeneral.
     *
     * @return string
     */
    public function getMemoGeneral()
    {
        return $this->memoGeneral;
    }

    /**
     * Set memoDeclaration.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setMemoDeclaration($value)
    {
        $this->memoDeclaration = $value;
        return $this;
    }

    /**
     * Get memoDeclaration.
     *
     * @return string
     */
    public function getMemoDeclaration()
    {
        return $this->memoDeclaration;
    }

    /**
     * Set memoWeekLog.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setMemoWeekLog($value)
    {
        $this->memoWeekLog = $value;
        return $this;
    }

    /**
     * Get memoWeekLog.
     *
     * @return string
     */
    public function getMemoWeekLog()
    {
        return $this->memoWeekLog;
    }

    /**
     * Set invoiceSubject.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setInvoiceSubject($value)
    {
        $this->invoiceSubject = $value;
        return $this;
    }

    /**
     * Get invoiceSubject.
     *
     * @return string
     */
    public function getInvoiceSubject()
    {
        return $this->invoiceSubject;
    }

    /**
     * Set noticePeriodDays.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setNoticePeriodDays($value)
    {
        $this->noticePeriodDays = $value;
        return $this;
    }

    /**
     * Get noticePeriodDays.
     *
     * @return integer
     */
    public function getNoticePeriodDays()
    {
        return $this->noticePeriodDays;
    }

    /**
     * Set signatureRequired.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setSignatureRequired($value)
    {
        $this->signatureRequired = $value;
        return $this;
    }

    /**
     * Get signatureRequired.
     *
     * @return integer
     */
    public function getSignatureRequired()
    {
        return $this->signatureRequired;
    }

    /**
     * Set hourlyWageStandBy.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setHourlyWageStandBy($value)
    {
        $this->hourlyWageStandBy = $value;
        return $this;
    }

    /**
     * Get hourlyWageStandBy.
     *
     * @return float
     */
    public function getHourlyWageStandBy()
    {
        return $this->hourlyWageStandBy;
    }

    /**
     * Set templateName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setTemplateName($value)
    {
        $this->templateName = $value;
        return $this;
    }

    /**
     * Get templateName.
     *
     * @return string
     */
    public function getTemplateName()
    {
        return $this->templateName;
    }

    /**
     * Set hourlyTariffExtraNotes.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setHourlyTariffExtraNotes($value)
    {
        $this->hourlyTariffExtraNotes = $value;
        return $this;
    }

    /**
     * Get hourlyTariffExtraNotes.
     *
     * @return string
     */
    public function getHourlyTariffExtraNotes()
    {
        return $this->hourlyTariffExtraNotes;
    }

    /**
     * Set pgcHours.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setPgcHours($value)
    {
        $this->pgcHours = $value;
        return $this;
    }

    /**
     * Get pgcHours.
     *
     * @return float
     */
    public function getPgcHours()
    {
        return $this->pgcHours;
    }

    /**
     * Set rotationOff.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setRotationOff($value)
    {
        $this->rotationOff = $value;
        return $this;
    }

    /**
     * Get rotationOff.
     *
     * @return float
     */
    public function getRotationOff()
    {
        return $this->rotationOff;
    }

    /**
     * Set rotationOn.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setRotationOn($value)
    {
        $this->rotationOn = $value;
        return $this;
    }

    /**
     * Get rotationOn.
     *
     * @return float
     */
    public function getRotationOn()
    {
        return $this->rotationOn;
    }

    /**
     * Set lastTrialDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setLastTrialDate($value)
    {
        $this->lastTrialDate = $value;
        return $this;
    }

    /**
     * Get lastTrialDate.
     *
     * @return string
     */
    public function getLastTrialDate()
    {
        return $this->lastTrialDate;
    }

    /**
     * Set status.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setStatus($value)
    {
        $this->status = $value;
        return $this;
    }

    /**
     * Get status.
     *
     * @return integer
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Set friWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setFriWorkMinutes($value)
    {
        $this->friWorkMinutes = $value;
        return $this;
    }

    /**
     * Get friWorkMinutes.
     *
     * @return integer
     */
    public function getFriWorkMinutes()
    {
        return $this->friWorkMinutes;
    }

    /**
     * Set jobInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setJobInformation($value)
    {
        $this->jobInformation = $value;
        return $this;
    }

    /**
     * Get jobInformation.
     *
     * @return string
     */
    public function getJobInformation()
    {
        return $this->jobInformation;
    }

    /**
     * Set monWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setMonWorkMinutes($value)
    {
        $this->monWorkMinutes = $value;
        return $this;
    }

    /**
     * Get monWorkMinutes.
     *
     * @return integer
     */
    public function getMonWorkMinutes()
    {
        return $this->monWorkMinutes;
    }

    /**
     * Set phoneNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setPhoneNumber($value)
    {
        $this->phoneNumber = $value;
        return $this;
    }

    /**
     * Get phoneNumber.
     *
     * @return string
     */
    public function getPhoneNumber()
    {
        return $this->phoneNumber;
    }

    /**
     * Set satWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setSatWorkMinutes($value)
    {
        $this->satWorkMinutes = $value;
        return $this;
    }

    /**
     * Get satWorkMinutes.
     *
     * @return integer
     */
    public function getSatWorkMinutes()
    {
        return $this->satWorkMinutes;
    }

    /**
     * Set sunWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setSunWorkMinutes($value)
    {
        $this->sunWorkMinutes = $value;
        return $this;
    }

    /**
     * Get sunWorkMinutes.
     *
     * @return integer
     */
    public function getSunWorkMinutes()
    {
        return $this->sunWorkMinutes;
    }

    /**
     * Set thuWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setThuWorkMinutes($value)
    {
        $this->thuWorkMinutes = $value;
        return $this;
    }

    /**
     * Get thuWorkMinutes.
     *
     * @return integer
     */
    public function getThuWorkMinutes()
    {
        return $this->thuWorkMinutes;
    }

    /**
     * Set tueWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setTueWorkMinutes($value)
    {
        $this->tueWorkMinutes = $value;
        return $this;
    }

    /**
     * Get tueWorkMinutes.
     *
     * @return integer
     */
    public function getTueWorkMinutes()
    {
        return $this->tueWorkMinutes;
    }

    /**
     * Set wedWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setWedWorkMinutes($value)
    {
        $this->wedWorkMinutes = $value;
        return $this;
    }

    /**
     * Get wedWorkMinutes.
     *
     * @return integer
     */
    public function getWedWorkMinutes()
    {
        return $this->wedWorkMinutes;
    }

    /**
     * Set externalIdentifier.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setExternalIdentifier($value)
    {
        $this->externalIdentifier = $value;
        return $this;
    }

    /**
     * Get externalIdentifier.
     *
     * @return string
     */
    public function getExternalIdentifier()
    {
        return $this->externalIdentifier;
    }

    /**
     * Set forecastDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setForecastDate($value)
    {
        $this->forecastDate = $value;
        return $this;
    }

    /**
     * Get forecastDate.
     *
     * @return string
     */
    public function getForecastDate()
    {
        return $this->forecastDate;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set invoiceDiscountPercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setInvoiceDiscountPercentage($value)
    {
        $this->invoiceDiscountPercentage = $value;
        return $this;
    }

    /**
     * Get invoiceDiscountPercentage.
     *
     * @return float
     */
    public function getInvoiceDiscountPercentage()
    {
        return $this->invoiceDiscountPercentage;
    }

    /**
     * Set customerReference.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setCustomerReference($value)
    {
        $this->customerReference = $value;
        return $this;
    }

    /**
     * Get customerReference.
     *
     * @return string
     */
    public function getCustomerReference()
    {
        return $this->customerReference;
    }

    /**
     * Set isTemplate.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setIsTemplate($value)
    {
        $this->isTemplate = $value;
        return $this;
    }

    /**
     * Get isTemplate.
     *
     * @return integer
     */
    public function getIsTemplate()
    {
        return $this->isTemplate;
    }

    /**
     * Set name.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setName($value)
    {
        $this->name = $value;
        return $this;
    }

    /**
     * Get name.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set costPrice.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setCostPrice($value)
    {
        $this->costPrice = $value;
        return $this;
    }

    /**
     * Get costPrice.
     *
     * @return float
     */
    public function getCostPrice()
    {
        return $this->costPrice;
    }

    /**
     * Set sellingPrice.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setSellingPrice($value)
    {
        $this->sellingPrice = $value;
        return $this;
    }

    /**
     * Get sellingPrice.
     *
     * @return float
     */
    public function getSellingPrice()
    {
        return $this->sellingPrice;
    }

    /**
     * Set toEmployee.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Employee $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToEmployee($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Employee($value); 
        }                 
        $this->toEmployee = $value;
        return $this;
    }

    /**
     * Get toEmployee.
     *
     * @return Carerix_Api_Rest_Entity_Employee
     */
    public function getToEmployee()
    {
        return $this->toEmployee;
    }

    /**
     * Set toVacancy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Vacancy $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToVacancy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Vacancy($value); 
        }                 
        $this->toVacancy = $value;
        return $this;
    }

    /**
     * Get toVacancy.
     *
     * @return Carerix_Api_Rest_Entity_Vacancy
     */
    public function getToVacancy()
    {
        return $this->toVacancy;
    }

    /**
     * Set allWeekHours.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setAllWeekHours($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->allWeekHours = $values;
        return $this;
    }

    /**
     * Get allWeekHours.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Week_Hour
     */
    public function getAllWeekHours($index = null)
    {
        if($index !== null) {
            return $this->allWeekHours[$index];
        }
        return $this->allWeekHours;
    }

    /**
     * Set owner.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setOwner($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->owner = $value;
        return $this;
    }

    /**
     * Get owner.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Set toMatch.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Match $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToMatch($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Match($value); 
        }                 
        $this->toMatch = $value;
        return $this;
    }

    /**
     * Get toMatch.
     *
     * @return Carerix_Api_Rest_Entity_Match
     */
    public function getToMatch()
    {
        return $this->toMatch;
    }

    /**
     * Set attachments.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setAttachments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->attachments = $values;
        return $this;
    }

    /**
     * Get attachments.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Attachment
     */
    public function getAttachments($index = null)
    {
        if($index !== null) {
            return $this->attachments[$index];
        }
        return $this->attachments;
    }

    /**
     * Set toContractTypeNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToContractTypeNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toContractTypeNode = $value;
        return $this;
    }

    /**
     * Get toContractTypeNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToContractTypeNode()
    {
        return $this->toContractTypeNode;
    }

    /**
     * Set toInvoicePeriodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToInvoicePeriodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoicePeriodNode = $value;
        return $this;
    }

    /**
     * Get toInvoicePeriodNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoicePeriodNode()
    {
        return $this->toInvoicePeriodNode;
    }

    /**
     * Set toWorkUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToWorkUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toWorkUnitNode = $value;
        return $this;
    }

    /**
     * Get toWorkUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToWorkUnitNode()
    {
        return $this->toWorkUnitNode;
    }

    /**
     * Set toRotationOffUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToRotationOffUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toRotationOffUnitNode = $value;
        return $this;
    }

    /**
     * Get toRotationOffUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToRotationOffUnitNode()
    {
        return $this->toRotationOffUnitNode;
    }

    /**
     * Set toRotationOnUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToRotationOnUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toRotationOnUnitNode = $value;
        return $this;
    }

    /**
     * Get toRotationOnUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToRotationOnUnitNode()
    {
        return $this->toRotationOnUnitNode;
    }

    /**
     * Set toPgcHoursUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToPgcHoursUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPgcHoursUnitNode = $value;
        return $this;
    }

    /**
     * Get toPgcHoursUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPgcHoursUnitNode()
    {
        return $this->toPgcHoursUnitNode;
    }

    /**
     * Set toNoticeUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToNoticeUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toNoticeUnitNode = $value;
        return $this;
    }

    /**
     * Get toNoticeUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToNoticeUnitNode()
    {
        return $this->toNoticeUnitNode;
    }

    /**
     * Set _todos.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function set_todos($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->_todos = $values;
        return $this;
    }

    /**
     * Get _todos.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_To_Do
     */
    public function get_todos($index = null)
    {
        if($index !== null) {
            return $this->_todos[$index];
        }
        return $this->_todos;
    }

    /**
     * Set toEndReasonNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToEndReasonNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toEndReasonNode = $value;
        return $this;
    }

    /**
     * Get toEndReasonNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToEndReasonNode()
    {
        return $this->toEndReasonNode;
    }

    /**
     * Set finances.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setFinances($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->finances = $values;
        return $this;
    }

    /**
     * Get finances.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Finance
     */
    public function getFinances($index = null)
    {
        if($index !== null) {
            return $this->finances[$index];
        }
        return $this->finances;
    }

    /**
     * Set weekHourJobViews.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setWeekHourJobViews($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->weekHourJobViews = $values;
        return $this;
    }

    /**
     * Get weekHourJobViews.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Week_Hour_Job_View
     */
    public function getWeekHourJobViews($index = null)
    {
        if($index !== null) {
            return $this->weekHourJobViews[$index];
        }
        return $this->weekHourJobViews;
    }

    /**
     * Set toStatusNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToStatusNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toStatusNode = $value;
        return $this;
    }

    /**
     * Get toStatusNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToStatusNode()
    {
        return $this->toStatusNode;
    }

    /**
     * Set documents.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setDocuments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->documents = $values;
        return $this;
    }

    /**
     * Get documents.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Job_Document
     */
    public function getDocuments($index = null)
    {
        if($index !== null) {
            return $this->documents[$index];
        }
        return $this->documents;
    }

    /**
     * Set toWeekHourCompany.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToWeekHourCompany($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->toWeekHourCompany = $value;
        return $this;
    }

    /**
     * Get toWeekHourCompany.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getToWeekHourCompany()
    {
        return $this->toWeekHourCompany;
    }

    /**
     * Set attributeChanges.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setAttributeChanges($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->attributeChanges = $values;
        return $this;
    }

    /**
     * Get attributeChanges.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Attribute_Change
     */
    public function getAttributeChanges($index = null)
    {
        if($index !== null) {
            return $this->attributeChanges[$index];
        }
        return $this->attributeChanges;
    }

    /**
     * Set toHoursApprovementNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToHoursApprovementNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toHoursApprovementNode = $value;
        return $this;
    }

    /**
     * Get toHoursApprovementNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToHoursApprovementNode()
    {
        return $this->toHoursApprovementNode;
    }

    /**
     * Set toPaymentPeriodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToPaymentPeriodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPaymentPeriodNode = $value;
        return $this;
    }

    /**
     * Get toPaymentPeriodNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPaymentPeriodNode()
    {
        return $this->toPaymentPeriodNode;
    }

    /**
     * Set toTaxRateNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToTaxRateNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toTaxRateNode = $value;
        return $this;
    }

    /**
     * Get toTaxRateNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToTaxRateNode()
    {
        return $this->toTaxRateNode;
    }

    /**
     * Set invoiceLines.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setInvoiceLines($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->invoiceLines = $values;
        return $this;
    }

    /**
     * Get invoiceLines.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Invoice_Line
     */
    public function getInvoiceLines($index = null)
    {
        if($index !== null) {
            return $this->invoiceLines[$index];
        }
        return $this->invoiceLines;
    }

    /**
     * Set createdBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setCreatedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->createdBy = $value;
        return $this;
    }

    /**
     * Get createdBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set modifiedBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setModifiedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->modifiedBy = $value;
        return $this;
    }

    /**
     * Get modifiedBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getModifiedBy()
    {
        return $this->modifiedBy;
    }

    /**
     * Set toCostPriceCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToCostPriceCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCostPriceCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toCostPriceCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCostPriceCurrencyNode()
    {
        return $this->toCostPriceCurrencyNode;
    }

    /**
     * Set toCostPriceUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToCostPriceUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCostPriceUnitNode = $value;
        return $this;
    }

    /**
     * Get toCostPriceUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCostPriceUnitNode()
    {
        return $this->toCostPriceUnitNode;
    }

    /**
     * Set toSellingPriceCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToSellingPriceCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSellingPriceCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toSellingPriceCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSellingPriceCurrencyNode()
    {
        return $this->toSellingPriceCurrencyNode;
    }

    /**
     * Set toSellingPriceUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setToSellingPriceUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSellingPriceUnitNode = $value;
        return $this;
    }

    /**
     * Get toSellingPriceUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSellingPriceUnitNode()
    {
        return $this->toSellingPriceUnitNode;
    }

    /**
     * Set groupNodes.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Job
     */
    public function setGroupNodes($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->groupNodes = $values;
        return $this;
    }

    /**
     * Get groupNodes.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Data_Node
     */
    public function getGroupNodes($index = null)
    {
        if($index !== null) {
            return $this->groupNodes[$index];
        }
        return $this->groupNodes;
    }


}