<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Sun, 21 Aug 2011 18:32:05 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_Match extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $creationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $recruiterPreferenceKey = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $proofPeriod = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 30
     */
    public $agreedSalary = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $jobStartDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $notes = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $sourceInfo = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $invoiceRate = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $wageRate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $motivation = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $wageRatePerHour = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_DataType_NSDictionary|array
     * @value-class NSDictionary
     * @allows-null 1
     */
    public $evaluation = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $sortOrder = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isConfidential = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $costPrice = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $sellingPrice = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Employee
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Employee")
     * @mandatory 1
     * @destination-entity CREmployee
     * @to-many 0
     * @name toEmployee
     */
    public $toEmployee = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Vacancy
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Vacancy")
     * @mandatory 1
     * @destination-entity CRVacancy
     * @to-many 0
     * @name toVacancy
     */
    public $toVacancy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name modifiedBy
     */
    public $modifiedBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name owner
     */
    public $owner = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name createdBy
     */
    public $createdBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Attachment")
     * @mandatory 0
     * @destination-entity CRAttachment
     * @to-many 1
     * @name attachments
     */
    public $attachments = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Publication
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Publication")
     * @mandatory 0
     * @destination-entity CRPublication
     * @to-many 0
     * @name toPublication
     */
    public $toPublication = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Medium
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Medium")
     * @mandatory 0
     * @destination-entity CRMedium
     * @to-many 0
     * @name toMedium
     */
    public $toMedium = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Status_Info
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Status_Info")
     * @mandatory 0
     * @destination-entity CRStatusInfo
     * @to-many 0
     * @name statusInfo
     */
    public $statusInfo = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Job")
     * @mandatory 0
     * @destination-entity CRJob
     * @to-many 1
     * @name jobs
     */
    public $jobs = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSourceNode
     */
    public $toSourceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toWageRateCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toWageRateCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toWageRateUnitNode
     * @qualifier ((typeID = 152) or (typeID = 0))
     * @default 1
     * @nodeType Inkooptarief-eenheid
     */
    public $toWageRateUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceRateCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toInvoiceRateCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceRateUnitNode
     * @qualifier ((typeID = 153) or (typeID = 0))
     * @default 1
     * @nodeType Verkooptarief-eenheid
     */
    public $toInvoiceRateUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toLevel2Company
     */
    public $toLevel2Company = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toLevel2User
     */
    public $toLevel2User = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toLevel1Company
     */
    public $toLevel1Company = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toLevel1User
     */
    public $toLevel1User = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Attribute_Change")
     * @mandatory 0
     * @destination-entity CRAttributeChange
     * @to-many 1
     * @name attributeChanges
     * @qualifier (attributeEntityName = 'CRMatch')
     */
    public $attributeChanges = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User_Role
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User_Role")
     * @mandatory 0
     * @destination-entity CRUserRole
     * @to-many 0
     * @name toConfidentialUserRole
     */
    public $toConfidentialUserRole = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCostPriceCurrencyNode
     */
    public $toCostPriceCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCostPriceUnitNode
     */
    public $toCostPriceUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSellingPriceCurrencyNode
     */
    public $toSellingPriceCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSellingPriceUnitNode
     */
    public $toSellingPriceUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 1
     * @name groupNodes
     */
    public $groupNodes = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("matchID");
        $entityConfiguration->setName("match");
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set recruiterPreferenceKey.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setRecruiterPreferenceKey($value)
    {
        $this->recruiterPreferenceKey = $value;
        return $this;
    }

    /**
     * Get recruiterPreferenceKey.
     *
     * @return integer
     */
    public function getRecruiterPreferenceKey()
    {
        return $this->recruiterPreferenceKey;
    }

    /**
     * Set proofPeriod.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setProofPeriod($value)
    {
        $this->proofPeriod = $value;
        return $this;
    }

    /**
     * Get proofPeriod.
     *
     * @return integer
     */
    public function getProofPeriod()
    {
        return $this->proofPeriod;
    }

    /**
     * Set agreedSalary.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setAgreedSalary($value)
    {
        $this->agreedSalary = $value;
        return $this;
    }

    /**
     * Get agreedSalary.
     *
     * @return string
     */
    public function getAgreedSalary()
    {
        return $this->agreedSalary;
    }

    /**
     * Set jobStartDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setJobStartDate($value)
    {
        $this->jobStartDate = $value;
        return $this;
    }

    /**
     * Get jobStartDate.
     *
     * @return string
     */
    public function getJobStartDate()
    {
        return $this->jobStartDate;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set notes.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setNotes($value)
    {
        $this->notes = $value;
        return $this;
    }

    /**
     * Get notes.
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set sourceInfo.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setSourceInfo($value)
    {
        $this->sourceInfo = $value;
        return $this;
    }

    /**
     * Get sourceInfo.
     *
     * @return string
     */
    public function getSourceInfo()
    {
        return $this->sourceInfo;
    }

    /**
     * Set invoiceRate.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setInvoiceRate($value)
    {
        $this->invoiceRate = $value;
        return $this;
    }

    /**
     * Get invoiceRate.
     *
     * @return float
     */
    public function getInvoiceRate()
    {
        return $this->invoiceRate;
    }

    /**
     * Set wageRate.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setWageRate($value)
    {
        $this->wageRate = $value;
        return $this;
    }

    /**
     * Get wageRate.
     *
     * @return float
     */
    public function getWageRate()
    {
        return $this->wageRate;
    }

    /**
     * Set motivation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setMotivation($value)
    {
        $this->motivation = $value;
        return $this;
    }

    /**
     * Get motivation.
     *
     * @return string
     */
    public function getMotivation()
    {
        return $this->motivation;
    }

    /**
     * Set wageRatePerHour.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setWageRatePerHour($value)
    {
        $this->wageRatePerHour = $value;
        return $this;
    }

    /**
     * Get wageRatePerHour.
     *
     * @return integer
     */
    public function getWageRatePerHour()
    {
        return $this->wageRatePerHour;
    }

    /**
     * Set evaluation.
     *
     * Provides a fluent interface.
     *
     * @param Carerix_Api_Rest_DataType_NSDictionary|array $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setEvaluation($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_DataType_NSDictionary($value);
        }
        $this->evaluation = $value;
        return $this;
    }

    /**
     * Get evaluation.
     *
     * @return Carerix_Api_Rest_DataType_NSDictionary|array
     */
    public function getEvaluation()
    {
        return $this->evaluation;
    }

    /**
     * Set sortOrder.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setSortOrder($value)
    {
        $this->sortOrder = $value;
        return $this;
    }

    /**
     * Get sortOrder.
     *
     * @return integer
     */
    public function getSortOrder()
    {
        return $this->sortOrder;
    }

    /**
     * Set isConfidential.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setIsConfidential($value)
    {
        $this->isConfidential = $value;
        return $this;
    }

    /**
     * Get isConfidential.
     *
     * @return integer
     */
    public function getIsConfidential()
    {
        return $this->isConfidential;
    }

    /**
     * Set costPrice.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setCostPrice($value)
    {
        $this->costPrice = $value;
        return $this;
    }

    /**
     * Get costPrice.
     *
     * @return float
     */
    public function getCostPrice()
    {
        return $this->costPrice;
    }

    /**
     * Set sellingPrice.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setSellingPrice($value)
    {
        $this->sellingPrice = $value;
        return $this;
    }

    /**
     * Get sellingPrice.
     *
     * @return float
     */
    public function getSellingPrice()
    {
        return $this->sellingPrice;
    }

    /**
     * Set toEmployee.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Employee $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToEmployee($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Employee($value); 
        }                 
        $this->toEmployee = $value;
        return $this;
    }

    /**
     * Get toEmployee.
     *
     * @return Carerix_Api_Rest_Entity_Employee
     */
    public function getToEmployee()
    {
        return $this->toEmployee;
    }

    /**
     * Set toVacancy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Vacancy $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToVacancy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Vacancy($value); 
        }                 
        $this->toVacancy = $value;
        return $this;
    }

    /**
     * Get toVacancy.
     *
     * @return Carerix_Api_Rest_Entity_Vacancy
     */
    public function getToVacancy()
    {
        return $this->toVacancy;
    }

    /**
     * Set modifiedBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setModifiedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->modifiedBy = $value;
        return $this;
    }

    /**
     * Get modifiedBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getModifiedBy()
    {
        return $this->modifiedBy;
    }

    /**
     * Set owner.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setOwner($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->owner = $value;
        return $this;
    }

    /**
     * Get owner.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Set createdBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setCreatedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->createdBy = $value;
        return $this;
    }

    /**
     * Get createdBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set attachments.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setAttachments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->attachments = $values;
        return $this;
    }

    /**
     * Get attachments.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Attachment
     */
    public function getAttachments($index = null)
    {
        if($index !== null) {
            return $this->attachments[$index];
        }
        return $this->attachments;
    }

    /**
     * Set toPublication.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Publication $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToPublication($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Publication($value); 
        }                 
        $this->toPublication = $value;
        return $this;
    }

    /**
     * Get toPublication.
     *
     * @return Carerix_Api_Rest_Entity_Publication
     */
    public function getToPublication()
    {
        return $this->toPublication;
    }

    /**
     * Set toMedium.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Medium $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToMedium($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Medium($value); 
        }                 
        $this->toMedium = $value;
        return $this;
    }

    /**
     * Get toMedium.
     *
     * @return Carerix_Api_Rest_Entity_Medium
     */
    public function getToMedium()
    {
        return $this->toMedium;
    }

    /**
     * Set statusInfo.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Status_Info $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setStatusInfo($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Status_Info($value); 
        }                 
        $this->statusInfo = $value;
        return $this;
    }

    /**
     * Get statusInfo.
     *
     * @return Carerix_Api_Rest_Entity_Status_Info
     */
    public function getStatusInfo()
    {
        return $this->statusInfo;
    }

    /**
     * Set jobs.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setJobs($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->jobs = $values;
        return $this;
    }

    /**
     * Get jobs.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Job
     */
    public function getJobs($index = null)
    {
        if($index !== null) {
            return $this->jobs[$index];
        }
        return $this->jobs;
    }

    /**
     * Set toSourceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToSourceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSourceNode = $value;
        return $this;
    }

    /**
     * Get toSourceNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSourceNode()
    {
        return $this->toSourceNode;
    }

    /**
     * Set toWageRateCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToWageRateCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toWageRateCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toWageRateCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToWageRateCurrencyNode()
    {
        return $this->toWageRateCurrencyNode;
    }

    /**
     * Set toWageRateUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToWageRateUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toWageRateUnitNode = $value;
        return $this;
    }

    /**
     * Get toWageRateUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToWageRateUnitNode()
    {
        return $this->toWageRateUnitNode;
    }

    /**
     * Set toInvoiceRateCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToInvoiceRateCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceRateCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceRateCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceRateCurrencyNode()
    {
        return $this->toInvoiceRateCurrencyNode;
    }

    /**
     * Set toInvoiceRateUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToInvoiceRateUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceRateUnitNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceRateUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceRateUnitNode()
    {
        return $this->toInvoiceRateUnitNode;
    }

    /**
     * Set toLevel2Company.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToLevel2Company($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->toLevel2Company = $value;
        return $this;
    }

    /**
     * Get toLevel2Company.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getToLevel2Company()
    {
        return $this->toLevel2Company;
    }

    /**
     * Set toLevel2User.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToLevel2User($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toLevel2User = $value;
        return $this;
    }

    /**
     * Get toLevel2User.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToLevel2User()
    {
        return $this->toLevel2User;
    }

    /**
     * Set toLevel1Company.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToLevel1Company($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->toLevel1Company = $value;
        return $this;
    }

    /**
     * Get toLevel1Company.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getToLevel1Company()
    {
        return $this->toLevel1Company;
    }

    /**
     * Set toLevel1User.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToLevel1User($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toLevel1User = $value;
        return $this;
    }

    /**
     * Get toLevel1User.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToLevel1User()
    {
        return $this->toLevel1User;
    }

    /**
     * Set attributeChanges.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setAttributeChanges($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->attributeChanges = $values;
        return $this;
    }

    /**
     * Get attributeChanges.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Attribute_Change
     */
    public function getAttributeChanges($index = null)
    {
        if($index !== null) {
            return $this->attributeChanges[$index];
        }
        return $this->attributeChanges;
    }

    /**
     * Set toConfidentialUserRole.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User_Role $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToConfidentialUserRole($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User_Role($value); 
        }                 
        $this->toConfidentialUserRole = $value;
        return $this;
    }

    /**
     * Get toConfidentialUserRole.
     *
     * @return Carerix_Api_Rest_Entity_User_Role
     */
    public function getToConfidentialUserRole()
    {
        return $this->toConfidentialUserRole;
    }

    /**
     * Set toCostPriceCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToCostPriceCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCostPriceCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toCostPriceCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCostPriceCurrencyNode()
    {
        return $this->toCostPriceCurrencyNode;
    }

    /**
     * Set toCostPriceUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToCostPriceUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCostPriceUnitNode = $value;
        return $this;
    }

    /**
     * Get toCostPriceUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCostPriceUnitNode()
    {
        return $this->toCostPriceUnitNode;
    }

    /**
     * Set toSellingPriceCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToSellingPriceCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSellingPriceCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toSellingPriceCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSellingPriceCurrencyNode()
    {
        return $this->toSellingPriceCurrencyNode;
    }

    /**
     * Set toSellingPriceUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setToSellingPriceUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSellingPriceUnitNode = $value;
        return $this;
    }

    /**
     * Get toSellingPriceUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSellingPriceUnitNode()
    {
        return $this->toSellingPriceUnitNode;
    }

    /**
     * Set groupNodes.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Match
     */
    public function setGroupNodes($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->groupNodes = $values;
        return $this;
    }

    /**
     * Get groupNodes.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Data_Node
     */
    public function getGroupNodes($index = null)
    {
        if($index !== null) {
            return $this->groupNodes[$index];
        }
        return $this->groupNodes;
    }


}