<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Sun, 21 Aug 2011 18:32:08 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_Publication extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $publicationID = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $campaign = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $publicationStart = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $publicationEnd = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $deadlineMaterial = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $numberOfPublications = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $costExclVAT = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $confirmationClient = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $refresh = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $status = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $closed = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $creationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 64
     */
    public $externalIdentifier = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 15
     */
    public $vacancyNo = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $deleted = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $applicationContactInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $companyInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $functionContactInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $introInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $layoutInstruction = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $notes = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $offerInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $publicationSpecifications = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $requirementsInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $titleInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $vacancyInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 100
     */
    public $workLocation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $metaTags = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $log = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000
     */
    public $lockStatusString = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 64
     */
    public $mainPublication = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000
     */
    public $applyUrl = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Vacancy
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Vacancy")
     * @mandatory 0
     * @destination-entity CRVacancy
     * @to-many 0
     * @name toVacancy
     */
    public $toVacancy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name createdBy
     */
    public $createdBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name owner
     */
    public $owner = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name modifiedBy
     */
    public $modifiedBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Medium
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Medium")
     * @mandatory 0
     * @destination-entity CRMedium
     * @to-many 0
     * @name toMedium
     */
    public $toMedium = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCostCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toCostCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Posting")
     * @mandatory 0
     * @destination-entity CRPosting
     * @to-many 1
     * @name postings
     */
    public $postings = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toStatusReservationNode
     * @qualifier ((typeID = 168) or (typeID = 0))
     * @default
     * @nodeType Publicatie-Status-Reservering
     */
    public $toStatusReservationNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toStatusNode
     * @qualifier ((typeID = 170) or (typeID = 0))
     * @default 1
     * @nodeType Publicatie-status
     */
    public $toStatusNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPostingFunction0
     */
    public $toPostingFunction0 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPostingFunction1
     */
    public $toPostingFunction1 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPostingEducation0
     */
    public $toPostingEducation0 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPostingEducation1
     */
    public $toPostingEducation1 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPostingEducation2
     */
    public $toPostingEducation2 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPostingRegion
     */
    public $toPostingRegion = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPostingEmployment
     */
    public $toPostingEmployment = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPostingProfessionalLevel
     */
    public $toPostingProfessionalLevel = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Attribute_Change")
     * @mandatory 0
     * @destination-entity CRAttributeChange
     * @to-many 1
     * @name attributeChanges
     * @qualifier (attributeEntityName = 'CRPublication')
     */
    public $attributeChanges = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("publicationID");
        $entityConfiguration->setName("publication");
    }

    /**
     * Set publicationID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setPublicationID($value)
    {
        $this->publicationID = $value;
        return $this;
    }

    /**
     * Get publicationID.
     *
     * @return integer
     */
    public function getPublicationID()
    {
        return $this->publicationID;
    }

    /**
     * Set campaign.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setCampaign($value)
    {
        $this->campaign = $value;
        return $this;
    }

    /**
     * Get campaign.
     *
     * @return string
     */
    public function getCampaign()
    {
        return $this->campaign;
    }

    /**
     * Set publicationStart.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setPublicationStart($value)
    {
        $this->publicationStart = $value;
        return $this;
    }

    /**
     * Get publicationStart.
     *
     * @return string
     */
    public function getPublicationStart()
    {
        return $this->publicationStart;
    }

    /**
     * Set publicationEnd.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setPublicationEnd($value)
    {
        $this->publicationEnd = $value;
        return $this;
    }

    /**
     * Get publicationEnd.
     *
     * @return string
     */
    public function getPublicationEnd()
    {
        return $this->publicationEnd;
    }

    /**
     * Set deadlineMaterial.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setDeadlineMaterial($value)
    {
        $this->deadlineMaterial = $value;
        return $this;
    }

    /**
     * Get deadlineMaterial.
     *
     * @return string
     */
    public function getDeadlineMaterial()
    {
        return $this->deadlineMaterial;
    }

    /**
     * Set numberOfPublications.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setNumberOfPublications($value)
    {
        $this->numberOfPublications = $value;
        return $this;
    }

    /**
     * Get numberOfPublications.
     *
     * @return integer
     */
    public function getNumberOfPublications()
    {
        return $this->numberOfPublications;
    }

    /**
     * Set costExclVAT.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setCostExclVAT($value)
    {
        $this->costExclVAT = $value;
        return $this;
    }

    /**
     * Get costExclVAT.
     *
     * @return float
     */
    public function getCostExclVAT()
    {
        return $this->costExclVAT;
    }

    /**
     * Set confirmationClient.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setConfirmationClient($value)
    {
        $this->confirmationClient = $value;
        return $this;
    }

    /**
     * Get confirmationClient.
     *
     * @return integer
     */
    public function getConfirmationClient()
    {
        return $this->confirmationClient;
    }

    /**
     * Set refresh.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setRefresh($value)
    {
        $this->refresh = $value;
        return $this;
    }

    /**
     * Get refresh.
     *
     * @return integer
     */
    public function getRefresh()
    {
        return $this->refresh;
    }

    /**
     * Set status.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setStatus($value)
    {
        $this->status = $value;
        return $this;
    }

    /**
     * Get status.
     *
     * @return integer
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Set closed.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setClosed($value)
    {
        $this->closed = $value;
        return $this;
    }

    /**
     * Get closed.
     *
     * @return integer
     */
    public function getClosed()
    {
        return $this->closed;
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set externalIdentifier.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setExternalIdentifier($value)
    {
        $this->externalIdentifier = $value;
        return $this;
    }

    /**
     * Get externalIdentifier.
     *
     * @return string
     */
    public function getExternalIdentifier()
    {
        return $this->externalIdentifier;
    }

    /**
     * Set vacancyNo.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setVacancyNo($value)
    {
        $this->vacancyNo = $value;
        return $this;
    }

    /**
     * Get vacancyNo.
     *
     * @return string
     */
    public function getVacancyNo()
    {
        return $this->vacancyNo;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set deleted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setDeleted($value)
    {
        $this->deleted = $value;
        return $this;
    }

    /**
     * Get deleted.
     *
     * @return integer
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set applicationContactInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setApplicationContactInformation($value)
    {
        $this->applicationContactInformation = $value;
        return $this;
    }

    /**
     * Get applicationContactInformation.
     *
     * @return string
     */
    public function getApplicationContactInformation()
    {
        return $this->applicationContactInformation;
    }

    /**
     * Set companyInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setCompanyInformation($value)
    {
        $this->companyInformation = $value;
        return $this;
    }

    /**
     * Get companyInformation.
     *
     * @return string
     */
    public function getCompanyInformation()
    {
        return $this->companyInformation;
    }

    /**
     * Set functionContactInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setFunctionContactInformation($value)
    {
        $this->functionContactInformation = $value;
        return $this;
    }

    /**
     * Get functionContactInformation.
     *
     * @return string
     */
    public function getFunctionContactInformation()
    {
        return $this->functionContactInformation;
    }

    /**
     * Set introInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setIntroInformation($value)
    {
        $this->introInformation = $value;
        return $this;
    }

    /**
     * Get introInformation.
     *
     * @return string
     */
    public function getIntroInformation()
    {
        return $this->introInformation;
    }

    /**
     * Set layoutInstruction.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setLayoutInstruction($value)
    {
        $this->layoutInstruction = $value;
        return $this;
    }

    /**
     * Get layoutInstruction.
     *
     * @return string
     */
    public function getLayoutInstruction()
    {
        return $this->layoutInstruction;
    }

    /**
     * Set notes.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setNotes($value)
    {
        $this->notes = $value;
        return $this;
    }

    /**
     * Get notes.
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set offerInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setOfferInformation($value)
    {
        $this->offerInformation = $value;
        return $this;
    }

    /**
     * Get offerInformation.
     *
     * @return string
     */
    public function getOfferInformation()
    {
        return $this->offerInformation;
    }

    /**
     * Set publicationSpecifications.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setPublicationSpecifications($value)
    {
        $this->publicationSpecifications = $value;
        return $this;
    }

    /**
     * Get publicationSpecifications.
     *
     * @return string
     */
    public function getPublicationSpecifications()
    {
        return $this->publicationSpecifications;
    }

    /**
     * Set requirementsInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setRequirementsInformation($value)
    {
        $this->requirementsInformation = $value;
        return $this;
    }

    /**
     * Get requirementsInformation.
     *
     * @return string
     */
    public function getRequirementsInformation()
    {
        return $this->requirementsInformation;
    }

    /**
     * Set titleInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setTitleInformation($value)
    {
        $this->titleInformation = $value;
        return $this;
    }

    /**
     * Get titleInformation.
     *
     * @return string
     */
    public function getTitleInformation()
    {
        return $this->titleInformation;
    }

    /**
     * Set vacancyInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setVacancyInformation($value)
    {
        $this->vacancyInformation = $value;
        return $this;
    }

    /**
     * Get vacancyInformation.
     *
     * @return string
     */
    public function getVacancyInformation()
    {
        return $this->vacancyInformation;
    }

    /**
     * Set workLocation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setWorkLocation($value)
    {
        $this->workLocation = $value;
        return $this;
    }

    /**
     * Get workLocation.
     *
     * @return string
     */
    public function getWorkLocation()
    {
        return $this->workLocation;
    }

    /**
     * Set metaTags.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setMetaTags($value)
    {
        $this->metaTags = $value;
        return $this;
    }

    /**
     * Get metaTags.
     *
     * @return string
     */
    public function getMetaTags()
    {
        return $this->metaTags;
    }

    /**
     * Set log.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setLog($value)
    {
        $this->log = $value;
        return $this;
    }

    /**
     * Get log.
     *
     * @return string
     */
    public function getLog()
    {
        return $this->log;
    }

    /**
     * Set lockStatusString.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setLockStatusString($value)
    {
        $this->lockStatusString = $value;
        return $this;
    }

    /**
     * Get lockStatusString.
     *
     * @return string
     */
    public function getLockStatusString()
    {
        return $this->lockStatusString;
    }

    /**
     * Set mainPublication.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setMainPublication($value)
    {
        $this->mainPublication = $value;
        return $this;
    }

    /**
     * Get mainPublication.
     *
     * @return string
     */
    public function getMainPublication()
    {
        return $this->mainPublication;
    }

    /**
     * Set applyUrl.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setApplyUrl($value)
    {
        $this->applyUrl = $value;
        return $this;
    }

    /**
     * Get applyUrl.
     *
     * @return string
     */
    public function getApplyUrl()
    {
        return $this->applyUrl;
    }

    /**
     * Set toVacancy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Vacancy $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToVacancy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Vacancy($value); 
        }                 
        $this->toVacancy = $value;
        return $this;
    }

    /**
     * Get toVacancy.
     *
     * @return Carerix_Api_Rest_Entity_Vacancy
     */
    public function getToVacancy()
    {
        return $this->toVacancy;
    }

    /**
     * Set createdBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setCreatedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->createdBy = $value;
        return $this;
    }

    /**
     * Get createdBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set owner.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setOwner($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->owner = $value;
        return $this;
    }

    /**
     * Get owner.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Set modifiedBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setModifiedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->modifiedBy = $value;
        return $this;
    }

    /**
     * Get modifiedBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getModifiedBy()
    {
        return $this->modifiedBy;
    }

    /**
     * Set toMedium.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Medium $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToMedium($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Medium($value); 
        }                 
        $this->toMedium = $value;
        return $this;
    }

    /**
     * Get toMedium.
     *
     * @return Carerix_Api_Rest_Entity_Medium
     */
    public function getToMedium()
    {
        return $this->toMedium;
    }

    /**
     * Set toCostCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToCostCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCostCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toCostCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCostCurrencyNode()
    {
        return $this->toCostCurrencyNode;
    }

    /**
     * Set postings.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setPostings($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->postings = $values;
        return $this;
    }

    /**
     * Get postings.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Posting
     */
    public function getPostings($index = null)
    {
        if($index !== null) {
            return $this->postings[$index];
        }
        return $this->postings;
    }

    /**
     * Set toStatusReservationNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToStatusReservationNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toStatusReservationNode = $value;
        return $this;
    }

    /**
     * Get toStatusReservationNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToStatusReservationNode()
    {
        return $this->toStatusReservationNode;
    }

    /**
     * Set toStatusNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToStatusNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toStatusNode = $value;
        return $this;
    }

    /**
     * Get toStatusNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToStatusNode()
    {
        return $this->toStatusNode;
    }

    /**
     * Set toPostingFunction0.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToPostingFunction0($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPostingFunction0 = $value;
        return $this;
    }

    /**
     * Get toPostingFunction0.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPostingFunction0()
    {
        return $this->toPostingFunction0;
    }

    /**
     * Set toPostingFunction1.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToPostingFunction1($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPostingFunction1 = $value;
        return $this;
    }

    /**
     * Get toPostingFunction1.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPostingFunction1()
    {
        return $this->toPostingFunction1;
    }

    /**
     * Set toPostingEducation0.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToPostingEducation0($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPostingEducation0 = $value;
        return $this;
    }

    /**
     * Get toPostingEducation0.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPostingEducation0()
    {
        return $this->toPostingEducation0;
    }

    /**
     * Set toPostingEducation1.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToPostingEducation1($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPostingEducation1 = $value;
        return $this;
    }

    /**
     * Get toPostingEducation1.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPostingEducation1()
    {
        return $this->toPostingEducation1;
    }

    /**
     * Set toPostingEducation2.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToPostingEducation2($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPostingEducation2 = $value;
        return $this;
    }

    /**
     * Get toPostingEducation2.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPostingEducation2()
    {
        return $this->toPostingEducation2;
    }

    /**
     * Set toPostingRegion.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToPostingRegion($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPostingRegion = $value;
        return $this;
    }

    /**
     * Get toPostingRegion.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPostingRegion()
    {
        return $this->toPostingRegion;
    }

    /**
     * Set toPostingEmployment.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToPostingEmployment($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPostingEmployment = $value;
        return $this;
    }

    /**
     * Get toPostingEmployment.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPostingEmployment()
    {
        return $this->toPostingEmployment;
    }

    /**
     * Set toPostingProfessionalLevel.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setToPostingProfessionalLevel($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPostingProfessionalLevel = $value;
        return $this;
    }

    /**
     * Get toPostingProfessionalLevel.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPostingProfessionalLevel()
    {
        return $this->toPostingProfessionalLevel;
    }

    /**
     * Set attributeChanges.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Publication
     */
    public function setAttributeChanges($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->attributeChanges = $values;
        return $this;
    }

    /**
     * Get attributeChanges.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Attribute_Change
     */
    public function getAttributeChanges($index = null)
    {
        if($index !== null) {
            return $this->attributeChanges[$index];
        }
        return $this->attributeChanges;
    }


}