<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Sun, 21 Aug 2011 18:32:08 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_Publication_Medium extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Medium
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Medium")
     * @mandatory 0
     * @destination-entity CRMedium
     * @to-many 0
     * @name toMedium
     */
    public $toMedium = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Publication
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Publication")
     * @mandatory 0
     * @destination-entity CRPublication
     * @to-many 0
     * @name toPublication
     */
    public $toPublication = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("publicationMediumID");
        $entityConfiguration->setName("publication-medium");
    }

    /**
     * Set toMedium.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Medium $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication_Medium
     */
    public function setToMedium($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Medium($value); 
        }                 
        $this->toMedium = $value;
        return $this;
    }

    /**
     * Get toMedium.
     *
     * @return Carerix_Api_Rest_Entity_Medium
     */
    public function getToMedium()
    {
        return $this->toMedium;
    }

    /**
     * Set toPublication.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Publication $value
     * @return Carerix_Api_Rest_Entity_Abstract_Publication_Medium
     */
    public function setToPublication($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Publication($value); 
        }                 
        $this->toPublication = $value;
        return $this;
    }

    /**
     * Get toPublication.
     *
     * @return Carerix_Api_Rest_Entity_Publication
     */
    public function getToPublication()
    {
        return $this->toPublication;
    }


}