<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Sun, 21 Aug 2011 18:32:17 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_Vacancy extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $creationDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $maxDistance = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $vacancyID = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 30
     */
    public $workPostalCode = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $deleted = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 60
     */
    public $jobTitle = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $startDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $endDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $numberOfVacancies = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $matchCountMO = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $minSalary = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $maxSalary = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 45
     */
    public $vacancyNo = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $hoursPerWeek = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $statusChangedDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isVirtual = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $copyID = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $fte = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isHidden = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isOpenApplication = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $rotationOff = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $rotationOn = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $friWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $monWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $satWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $sunWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $thuWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $tueWorkMinutes = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $wedWorkMinutes = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $successRatePercentage = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $estimatedAmount = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $realizedAmount = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $estimatedDays = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $realizedDays = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $arboRequirements = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $invoiceAttention = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $invoiceCity = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $invoiceNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 30
     */
    public $invoicePostalCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $invoiceStreet = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $vacancyInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $workCity = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $additionalInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $applicationContactInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $companyInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $contactInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 120
     */
    public $contractPeriod = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $hasBonus = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $hasCompanyCar = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $invoiceFullAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $invoiceNumberSuffix = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $notes = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $offerInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $reactionEndDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $requirements = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 80
     */
    public $salaryScale = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $trainingInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $sourceInfo = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $coordX = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $coordY = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isAnonymous = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $feePercentage = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $invoiceDiscountPercentage = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 100
     */
    public $workLocation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $titleInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $introInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $invoiceSubject = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $customerReference = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $numberOfInvoicePrints = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 200
     */
    public $invoiceEmailAddress = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isTemplate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isConfidential = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_DataType_NSArray|array
     * @value-class NSArray
     * @allows-null 1
     */
    public $userBonuses = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $invoiceCompanyName = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Match")
     * @mandatory 0
     * @destination-entity CRMatch
     * @to-many 1
     * @name matches
     */
    public $matches = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toUser
     */
    public $toUser = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name createdBy
     */
    public $createdBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name modifiedBy
     */
    public $modifiedBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name owner
     */
    public $owner = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Attachment")
     * @mandatory 0
     * @destination-entity CRAttachment
     * @to-many 1
     * @name attachments
     */
    public $attachments = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Publication")
     * @mandatory 0
     * @destination-entity CRPublication
     * @to-many 1
     * @name publications
     */
    public $publications = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toStatusNode
     * @qualifier ((typeID = 4) or (typeID = 0))
     * @default 1
     * @nodeType Vacature-status
     */
    public $toStatusNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSalaryPeriodNode
     * @qualifier ((typeID = 8) or (typeID = 0))
     * @default 1
     * @nodeType Salarisperiode
     */
    public $toSalaryPeriodNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toExperienceLevelNode
     * @qualifier ((typeID = 9) or (typeID = 0))
     * @default 1
     * @nodeType Ervaring
     */
    public $toExperienceLevelNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toProvince1Node
     */
    public $toProvince1Node = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toProductNode
     * @qualifier ((typeID = 24) or (typeID = 0))
     * @default 1
     * @nodeType Productgroep
     */
    public $toProductNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toProductTypeNode
     * @qualifier ((typeID = 25) or (typeID = 0))
     * @default 1
     * @nodeType Product
     */
    public $toProductTypeNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Vacancy_Education")
     * @mandatory 0
     * @destination-entity CRVacancyEducation
     * @to-many 1
     * @name educations
     */
    public $educations = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toVacancyHolder
     */
    public $toVacancyHolder = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toFunctionLevel1
     * @qualifier ((typeID = 40) or (typeID = 0))
     * @default 1
     * @nodeType Functie0
     */
    public $toFunctionLevel1 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toFunctionLevel2
     * @qualifier ((typeID = 41) or (typeID = 0))
     * @default 1
     * @nodeType Functie1
     */
    public $toFunctionLevel2 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toContractTypeNode
     * @qualifier ((typeID = 13) or (typeID = 0))
     * @default 1
     * @nodeType Dienstverband
     */
    public $toContractTypeNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toDriverLicenceNode
     * @qualifier ((typeID = 14) or (typeID = 0))
     * @default 1
     * @nodeType Rijbewijs
     */
    public $toDriverLicenceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toSignAuthority
     */
    public $toSignAuthority = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Vacancy_Training")
     * @mandatory 0
     * @destination-entity CRVacancyTraining
     * @to-many 1
     * @name trainings
     */
    public $trainings = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toFunctionTypeNode
     */
    public $toFunctionTypeNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCountry1Node
     */
    public $toCountry1Node = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSalaryCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toSalaryCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toWorkUnitNode
     * @qualifier ((typeID = 119) or (typeID = 0))
     * @default 1
     * @nodeType Werktijden-eenheid
     */
    public $toWorkUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toRotationOnUnitNode
     * @qualifier ((typeID = 118) or (typeID = 0))
     * @default 1
     * @nodeType Werkschema-eenheid
     */
    public $toRotationOnUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toRotationOffUnitNode
     * @qualifier ((typeID = 118) or (typeID = 0))
     * @default 1
     * @nodeType Werkschema-eenheid
     */
    public $toRotationOffUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toCompetitor
     */
    public $toCompetitor = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toResultNode
     * @qualifier ((typeID = 120) or (typeID = 0))
     * @default 1
     * @nodeType Project-resultaat
     */
    public $toResultNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toEstimatedAmountCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toEstimatedAmountCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toRealizedAmountCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toRealizedAmountCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceCountryNode
     * @qualifier ((typeID = 11) or (typeID = 0))
     * @default 1
     * @nodeType Land
     */
    public $toInvoiceCountryNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceProvinceNode
     * @qualifier ((typeID = 10) or (typeID = 0))
     * @default 1
     * @nodeType Regio
     */
    public $toInvoiceProvinceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSalaryScaleCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toSalaryScaleCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSalaryScaleNode
     * @qualifier ((typeID = 12) or (typeID = 0))
     * @default 1
     * @nodeType Salarisschaal
     */
    public $toSalaryScaleNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toWorkCountryNode
     * @qualifier ((typeID = 11) or (typeID = 0))
     * @default 1
     * @nodeType Land
     */
    public $toWorkCountryNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toWorkLevelNode
     * @qualifier ((typeID = 7) or (typeID = 0))
     * @default 1
     * @nodeType Functieniveau
     */
    public $toWorkLevelNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toCompany
     */
    public $toCompany = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toSourceNode
     * @qualifier ((typeID = 209) or (typeID = 0))
     * @default
     * @nodeType Bron-Vacature
     */
    public $toSourceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Job")
     * @mandatory 0
     * @destination-entity CRJob
     * @to-many 1
     * @name jobs
     */
    public $jobs = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toLevel3User
     */
    public $toLevel3User = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toLevel3Company
     */
    public $toLevel3Company = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toLevel2Company
     */
    public $toLevel2Company = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toLevel2User
     */
    public $toLevel2User = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name broughtInBy
     */
    public $broughtInBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Attribute_Change")
     * @mandatory 0
     * @destination-entity CRAttributeChange
     * @to-many 1
     * @name attributeChanges
     * @qualifier (attributeEntityName = 'CRVacancy')
     */
    public $attributeChanges = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toTaxRateNode
     * @qualifier ((typeID = 189) or (typeID = 0))
     * @default 1
     * @nodeType BTW-tarief
     */
    public $toTaxRateNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPaymentPeriodNode
     * @qualifier ((typeID = 62) or (typeID = 0))
     * @default 1
     * @nodeType Betalingstermijn
     */
    public $toPaymentPeriodNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Invoice_Line")
     * @mandatory 0
     * @destination-entity CRInvoiceLine
     * @to-many 1
     * @name invoiceLines
     */
    public $invoiceLines = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCountry2Node
     */
    public $toCountry2Node = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCountry3Node
     */
    public $toCountry3Node = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toProvince2Node
     */
    public $toProvince2Node = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toProvince3Node
     */
    public $toProvince3Node = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toInvoiceUser
     */
    public $toInvoiceUser = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Company
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Company")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toInvoiceCompany
     */
    public $toInvoiceCompany = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toVacancyTypeNode
     * @qualifier ((typeID = 215) or (typeID = 0))
     * @default 1
     * @nodeType Vacature-type
     */
    public $toVacancyTypeNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceHandlingNode
     * @qualifier ((typeID = 219) or (typeID = 0))
     * @default 1
     * @nodeType Factuurafhandeling
     */
    public $toInvoiceHandlingNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoiceLineLabelNode
     * @qualifier ((typeID = 216) or (typeID = 0))
     * @default 1
     * @nodeType Factuurregel-label
     */
    public $toInvoiceLineLabelNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPaymentPeriodStartDateNode
     * @qualifier ((typeID = 217) or (typeID = 0))
     * @default 1
     * @nodeType Betalingstermijn-startdatum
     */
    public $toPaymentPeriodStartDateNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCreditMethodNode
     * @qualifier ((typeID = 218) or (typeID = 0))
     * @default 1
     * @nodeType Crediteringsmethode
     */
    public $toCreditMethodNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 1
     * @name groupNodes
     */
    public $groupNodes = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCategoryNode
     * @qualifier ((typeID = 224) or (typeID = 0))
     * @default 1
     * @nodeType Vacature-categorie
     */
    public $toCategoryNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_Vacancy_User")
     * @mandatory 0
     * @destination-entity CRVacancyUser
     * @to-many 1
     * @name vacancyUsers
     */
    public $vacancyUsers = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Data_Node
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Data_Node")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toProjectNode
     */
    public $toProjectNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_User_Role
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_User_Role")
     * @mandatory 0
     * @destination-entity CRUserRole
     * @to-many 0
     * @name toConfidentialUserRole
     */
    public $toConfidentialUserRole = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_Agency
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_Agency")
     * @mandatory 0
     * @destination-entity CRAgency
     * @to-many 0
     * @name agency
     */
    public $agency = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("vacancyID");
        $entityConfiguration->setName("vacancy");
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set maxDistance.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setMaxDistance($value)
    {
        $this->maxDistance = $value;
        return $this;
    }

    /**
     * Get maxDistance.
     *
     * @return integer
     */
    public function getMaxDistance()
    {
        return $this->maxDistance;
    }

    /**
     * Set vacancyID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setVacancyID($value)
    {
        $this->vacancyID = $value;
        return $this;
    }

    /**
     * Get vacancyID.
     *
     * @return integer
     */
    public function getVacancyID()
    {
        return $this->vacancyID;
    }

    /**
     * Set workPostalCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setWorkPostalCode($value)
    {
        $this->workPostalCode = $value;
        return $this;
    }

    /**
     * Get workPostalCode.
     *
     * @return string
     */
    public function getWorkPostalCode()
    {
        return $this->workPostalCode;
    }

    /**
     * Set deleted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setDeleted($value)
    {
        $this->deleted = $value;
        return $this;
    }

    /**
     * Get deleted.
     *
     * @return integer
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set jobTitle.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setJobTitle($value)
    {
        $this->jobTitle = $value;
        return $this;
    }

    /**
     * Get jobTitle.
     *
     * @return string
     */
    public function getJobTitle()
    {
        return $this->jobTitle;
    }

    /**
     * Set startDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setStartDate($value)
    {
        $this->startDate = $value;
        return $this;
    }

    /**
     * Get startDate.
     *
     * @return string
     */
    public function getStartDate()
    {
        return $this->startDate;
    }

    /**
     * Set endDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setEndDate($value)
    {
        $this->endDate = $value;
        return $this;
    }

    /**
     * Get endDate.
     *
     * @return string
     */
    public function getEndDate()
    {
        return $this->endDate;
    }

    /**
     * Set numberOfVacancies.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setNumberOfVacancies($value)
    {
        $this->numberOfVacancies = $value;
        return $this;
    }

    /**
     * Get numberOfVacancies.
     *
     * @return integer
     */
    public function getNumberOfVacancies()
    {
        return $this->numberOfVacancies;
    }

    /**
     * Set matchCountMO.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setMatchCountMO($value)
    {
        $this->matchCountMO = $value;
        return $this;
    }

    /**
     * Get matchCountMO.
     *
     * @return integer
     */
    public function getMatchCountMO()
    {
        return $this->matchCountMO;
    }

    /**
     * Set minSalary.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setMinSalary($value)
    {
        $this->minSalary = $value;
        return $this;
    }

    /**
     * Get minSalary.
     *
     * @return float
     */
    public function getMinSalary()
    {
        return $this->minSalary;
    }

    /**
     * Set maxSalary.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setMaxSalary($value)
    {
        $this->maxSalary = $value;
        return $this;
    }

    /**
     * Get maxSalary.
     *
     * @return float
     */
    public function getMaxSalary()
    {
        return $this->maxSalary;
    }

    /**
     * Set vacancyNo.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setVacancyNo($value)
    {
        $this->vacancyNo = $value;
        return $this;
    }

    /**
     * Get vacancyNo.
     *
     * @return string
     */
    public function getVacancyNo()
    {
        return $this->vacancyNo;
    }

    /**
     * Set hoursPerWeek.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setHoursPerWeek($value)
    {
        $this->hoursPerWeek = $value;
        return $this;
    }

    /**
     * Get hoursPerWeek.
     *
     * @return float
     */
    public function getHoursPerWeek()
    {
        return $this->hoursPerWeek;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set statusChangedDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setStatusChangedDate($value)
    {
        $this->statusChangedDate = $value;
        return $this;
    }

    /**
     * Get statusChangedDate.
     *
     * @return string
     */
    public function getStatusChangedDate()
    {
        return $this->statusChangedDate;
    }

    /**
     * Set isVirtual.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setIsVirtual($value)
    {
        $this->isVirtual = $value;
        return $this;
    }

    /**
     * Get isVirtual.
     *
     * @return integer
     */
    public function getIsVirtual()
    {
        return $this->isVirtual;
    }

    /**
     * Set copyID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setCopyID($value)
    {
        $this->copyID = $value;
        return $this;
    }

    /**
     * Get copyID.
     *
     * @return integer
     */
    public function getCopyID()
    {
        return $this->copyID;
    }

    /**
     * Set fte.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setFte($value)
    {
        $this->fte = $value;
        return $this;
    }

    /**
     * Get fte.
     *
     * @return float
     */
    public function getFte()
    {
        return $this->fte;
    }

    /**
     * Set isHidden.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setIsHidden($value)
    {
        $this->isHidden = $value;
        return $this;
    }

    /**
     * Get isHidden.
     *
     * @return integer
     */
    public function getIsHidden()
    {
        return $this->isHidden;
    }

    /**
     * Set isOpenApplication.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setIsOpenApplication($value)
    {
        $this->isOpenApplication = $value;
        return $this;
    }

    /**
     * Get isOpenApplication.
     *
     * @return integer
     */
    public function getIsOpenApplication()
    {
        return $this->isOpenApplication;
    }

    /**
     * Set rotationOff.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setRotationOff($value)
    {
        $this->rotationOff = $value;
        return $this;
    }

    /**
     * Get rotationOff.
     *
     * @return float
     */
    public function getRotationOff()
    {
        return $this->rotationOff;
    }

    /**
     * Set rotationOn.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setRotationOn($value)
    {
        $this->rotationOn = $value;
        return $this;
    }

    /**
     * Get rotationOn.
     *
     * @return float
     */
    public function getRotationOn()
    {
        return $this->rotationOn;
    }

    /**
     * Set friWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setFriWorkMinutes($value)
    {
        $this->friWorkMinutes = $value;
        return $this;
    }

    /**
     * Get friWorkMinutes.
     *
     * @return integer
     */
    public function getFriWorkMinutes()
    {
        return $this->friWorkMinutes;
    }

    /**
     * Set monWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setMonWorkMinutes($value)
    {
        $this->monWorkMinutes = $value;
        return $this;
    }

    /**
     * Get monWorkMinutes.
     *
     * @return integer
     */
    public function getMonWorkMinutes()
    {
        return $this->monWorkMinutes;
    }

    /**
     * Set satWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setSatWorkMinutes($value)
    {
        $this->satWorkMinutes = $value;
        return $this;
    }

    /**
     * Get satWorkMinutes.
     *
     * @return integer
     */
    public function getSatWorkMinutes()
    {
        return $this->satWorkMinutes;
    }

    /**
     * Set sunWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setSunWorkMinutes($value)
    {
        $this->sunWorkMinutes = $value;
        return $this;
    }

    /**
     * Get sunWorkMinutes.
     *
     * @return integer
     */
    public function getSunWorkMinutes()
    {
        return $this->sunWorkMinutes;
    }

    /**
     * Set thuWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setThuWorkMinutes($value)
    {
        $this->thuWorkMinutes = $value;
        return $this;
    }

    /**
     * Get thuWorkMinutes.
     *
     * @return integer
     */
    public function getThuWorkMinutes()
    {
        return $this->thuWorkMinutes;
    }

    /**
     * Set tueWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setTueWorkMinutes($value)
    {
        $this->tueWorkMinutes = $value;
        return $this;
    }

    /**
     * Get tueWorkMinutes.
     *
     * @return integer
     */
    public function getTueWorkMinutes()
    {
        return $this->tueWorkMinutes;
    }

    /**
     * Set wedWorkMinutes.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setWedWorkMinutes($value)
    {
        $this->wedWorkMinutes = $value;
        return $this;
    }

    /**
     * Get wedWorkMinutes.
     *
     * @return integer
     */
    public function getWedWorkMinutes()
    {
        return $this->wedWorkMinutes;
    }

    /**
     * Set successRatePercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setSuccessRatePercentage($value)
    {
        $this->successRatePercentage = $value;
        return $this;
    }

    /**
     * Get successRatePercentage.
     *
     * @return float
     */
    public function getSuccessRatePercentage()
    {
        return $this->successRatePercentage;
    }

    /**
     * Set estimatedAmount.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setEstimatedAmount($value)
    {
        $this->estimatedAmount = $value;
        return $this;
    }

    /**
     * Get estimatedAmount.
     *
     * @return float
     */
    public function getEstimatedAmount()
    {
        return $this->estimatedAmount;
    }

    /**
     * Set realizedAmount.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setRealizedAmount($value)
    {
        $this->realizedAmount = $value;
        return $this;
    }

    /**
     * Get realizedAmount.
     *
     * @return float
     */
    public function getRealizedAmount()
    {
        return $this->realizedAmount;
    }

    /**
     * Set estimatedDays.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setEstimatedDays($value)
    {
        $this->estimatedDays = $value;
        return $this;
    }

    /**
     * Get estimatedDays.
     *
     * @return float
     */
    public function getEstimatedDays()
    {
        return $this->estimatedDays;
    }

    /**
     * Set realizedDays.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setRealizedDays($value)
    {
        $this->realizedDays = $value;
        return $this;
    }

    /**
     * Get realizedDays.
     *
     * @return float
     */
    public function getRealizedDays()
    {
        return $this->realizedDays;
    }

    /**
     * Set arboRequirements.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setArboRequirements($value)
    {
        $this->arboRequirements = $value;
        return $this;
    }

    /**
     * Get arboRequirements.
     *
     * @return string
     */
    public function getArboRequirements()
    {
        return $this->arboRequirements;
    }

    /**
     * Set invoiceAttention.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceAttention($value)
    {
        $this->invoiceAttention = $value;
        return $this;
    }

    /**
     * Get invoiceAttention.
     *
     * @return string
     */
    public function getInvoiceAttention()
    {
        return $this->invoiceAttention;
    }

    /**
     * Set invoiceCity.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceCity($value)
    {
        $this->invoiceCity = $value;
        return $this;
    }

    /**
     * Get invoiceCity.
     *
     * @return string
     */
    public function getInvoiceCity()
    {
        return $this->invoiceCity;
    }

    /**
     * Set invoiceNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceNumber($value)
    {
        $this->invoiceNumber = $value;
        return $this;
    }

    /**
     * Get invoiceNumber.
     *
     * @return string
     */
    public function getInvoiceNumber()
    {
        return $this->invoiceNumber;
    }

    /**
     * Set invoicePostalCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoicePostalCode($value)
    {
        $this->invoicePostalCode = $value;
        return $this;
    }

    /**
     * Get invoicePostalCode.
     *
     * @return string
     */
    public function getInvoicePostalCode()
    {
        return $this->invoicePostalCode;
    }

    /**
     * Set invoiceStreet.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceStreet($value)
    {
        $this->invoiceStreet = $value;
        return $this;
    }

    /**
     * Get invoiceStreet.
     *
     * @return string
     */
    public function getInvoiceStreet()
    {
        return $this->invoiceStreet;
    }

    /**
     * Set vacancyInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setVacancyInformation($value)
    {
        $this->vacancyInformation = $value;
        return $this;
    }

    /**
     * Get vacancyInformation.
     *
     * @return string
     */
    public function getVacancyInformation()
    {
        return $this->vacancyInformation;
    }

    /**
     * Set workCity.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setWorkCity($value)
    {
        $this->workCity = $value;
        return $this;
    }

    /**
     * Get workCity.
     *
     * @return string
     */
    public function getWorkCity()
    {
        return $this->workCity;
    }

    /**
     * Set additionalInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setAdditionalInformation($value)
    {
        $this->additionalInformation = $value;
        return $this;
    }

    /**
     * Get additionalInformation.
     *
     * @return string
     */
    public function getAdditionalInformation()
    {
        return $this->additionalInformation;
    }

    /**
     * Set applicationContactInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setApplicationContactInformation($value)
    {
        $this->applicationContactInformation = $value;
        return $this;
    }

    /**
     * Get applicationContactInformation.
     *
     * @return string
     */
    public function getApplicationContactInformation()
    {
        return $this->applicationContactInformation;
    }

    /**
     * Set companyInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setCompanyInformation($value)
    {
        $this->companyInformation = $value;
        return $this;
    }

    /**
     * Get companyInformation.
     *
     * @return string
     */
    public function getCompanyInformation()
    {
        return $this->companyInformation;
    }

    /**
     * Set contactInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setContactInformation($value)
    {
        $this->contactInformation = $value;
        return $this;
    }

    /**
     * Get contactInformation.
     *
     * @return string
     */
    public function getContactInformation()
    {
        return $this->contactInformation;
    }

    /**
     * Set contractPeriod.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setContractPeriod($value)
    {
        $this->contractPeriod = $value;
        return $this;
    }

    /**
     * Get contractPeriod.
     *
     * @return string
     */
    public function getContractPeriod()
    {
        return $this->contractPeriod;
    }

    /**
     * Set hasBonus.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setHasBonus($value)
    {
        $this->hasBonus = $value;
        return $this;
    }

    /**
     * Get hasBonus.
     *
     * @return integer
     */
    public function getHasBonus()
    {
        return $this->hasBonus;
    }

    /**
     * Set hasCompanyCar.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setHasCompanyCar($value)
    {
        $this->hasCompanyCar = $value;
        return $this;
    }

    /**
     * Get hasCompanyCar.
     *
     * @return integer
     */
    public function getHasCompanyCar()
    {
        return $this->hasCompanyCar;
    }

    /**
     * Set invoiceFullAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceFullAddress($value)
    {
        $this->invoiceFullAddress = $value;
        return $this;
    }

    /**
     * Get invoiceFullAddress.
     *
     * @return string
     */
    public function getInvoiceFullAddress()
    {
        return $this->invoiceFullAddress;
    }

    /**
     * Set invoiceNumberSuffix.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceNumberSuffix($value)
    {
        $this->invoiceNumberSuffix = $value;
        return $this;
    }

    /**
     * Get invoiceNumberSuffix.
     *
     * @return string
     */
    public function getInvoiceNumberSuffix()
    {
        return $this->invoiceNumberSuffix;
    }

    /**
     * Set notes.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setNotes($value)
    {
        $this->notes = $value;
        return $this;
    }

    /**
     * Get notes.
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set offerInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setOfferInformation($value)
    {
        $this->offerInformation = $value;
        return $this;
    }

    /**
     * Get offerInformation.
     *
     * @return string
     */
    public function getOfferInformation()
    {
        return $this->offerInformation;
    }

    /**
     * Set reactionEndDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setReactionEndDate($value)
    {
        $this->reactionEndDate = $value;
        return $this;
    }

    /**
     * Get reactionEndDate.
     *
     * @return string
     */
    public function getReactionEndDate()
    {
        return $this->reactionEndDate;
    }

    /**
     * Set requirements.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setRequirements($value)
    {
        $this->requirements = $value;
        return $this;
    }

    /**
     * Get requirements.
     *
     * @return string
     */
    public function getRequirements()
    {
        return $this->requirements;
    }

    /**
     * Set salaryScale.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setSalaryScale($value)
    {
        $this->salaryScale = $value;
        return $this;
    }

    /**
     * Get salaryScale.
     *
     * @return string
     */
    public function getSalaryScale()
    {
        return $this->salaryScale;
    }

    /**
     * Set trainingInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setTrainingInformation($value)
    {
        $this->trainingInformation = $value;
        return $this;
    }

    /**
     * Get trainingInformation.
     *
     * @return string
     */
    public function getTrainingInformation()
    {
        return $this->trainingInformation;
    }

    /**
     * Set sourceInfo.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setSourceInfo($value)
    {
        $this->sourceInfo = $value;
        return $this;
    }

    /**
     * Get sourceInfo.
     *
     * @return string
     */
    public function getSourceInfo()
    {
        return $this->sourceInfo;
    }

    /**
     * Set coordX.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setCoordX($value)
    {
        $this->coordX = $value;
        return $this;
    }

    /**
     * Get coordX.
     *
     * @return integer
     */
    public function getCoordX()
    {
        return $this->coordX;
    }

    /**
     * Set coordY.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setCoordY($value)
    {
        $this->coordY = $value;
        return $this;
    }

    /**
     * Get coordY.
     *
     * @return integer
     */
    public function getCoordY()
    {
        return $this->coordY;
    }

    /**
     * Set isAnonymous.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setIsAnonymous($value)
    {
        $this->isAnonymous = $value;
        return $this;
    }

    /**
     * Get isAnonymous.
     *
     * @return integer
     */
    public function getIsAnonymous()
    {
        return $this->isAnonymous;
    }

    /**
     * Set feePercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setFeePercentage($value)
    {
        $this->feePercentage = $value;
        return $this;
    }

    /**
     * Get feePercentage.
     *
     * @return float
     */
    public function getFeePercentage()
    {
        return $this->feePercentage;
    }

    /**
     * Set invoiceDiscountPercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceDiscountPercentage($value)
    {
        $this->invoiceDiscountPercentage = $value;
        return $this;
    }

    /**
     * Get invoiceDiscountPercentage.
     *
     * @return float
     */
    public function getInvoiceDiscountPercentage()
    {
        return $this->invoiceDiscountPercentage;
    }

    /**
     * Set workLocation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setWorkLocation($value)
    {
        $this->workLocation = $value;
        return $this;
    }

    /**
     * Get workLocation.
     *
     * @return string
     */
    public function getWorkLocation()
    {
        return $this->workLocation;
    }

    /**
     * Set titleInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setTitleInformation($value)
    {
        $this->titleInformation = $value;
        return $this;
    }

    /**
     * Get titleInformation.
     *
     * @return string
     */
    public function getTitleInformation()
    {
        return $this->titleInformation;
    }

    /**
     * Set introInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setIntroInformation($value)
    {
        $this->introInformation = $value;
        return $this;
    }

    /**
     * Get introInformation.
     *
     * @return string
     */
    public function getIntroInformation()
    {
        return $this->introInformation;
    }

    /**
     * Set invoiceSubject.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceSubject($value)
    {
        $this->invoiceSubject = $value;
        return $this;
    }

    /**
     * Get invoiceSubject.
     *
     * @return string
     */
    public function getInvoiceSubject()
    {
        return $this->invoiceSubject;
    }

    /**
     * Set customerReference.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setCustomerReference($value)
    {
        $this->customerReference = $value;
        return $this;
    }

    /**
     * Get customerReference.
     *
     * @return string
     */
    public function getCustomerReference()
    {
        return $this->customerReference;
    }

    /**
     * Set numberOfInvoicePrints.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setNumberOfInvoicePrints($value)
    {
        $this->numberOfInvoicePrints = $value;
        return $this;
    }

    /**
     * Get numberOfInvoicePrints.
     *
     * @return integer
     */
    public function getNumberOfInvoicePrints()
    {
        return $this->numberOfInvoicePrints;
    }

    /**
     * Set invoiceEmailAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceEmailAddress($value)
    {
        $this->invoiceEmailAddress = $value;
        return $this;
    }

    /**
     * Get invoiceEmailAddress.
     *
     * @return string
     */
    public function getInvoiceEmailAddress()
    {
        return $this->invoiceEmailAddress;
    }

    /**
     * Set isTemplate.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setIsTemplate($value)
    {
        $this->isTemplate = $value;
        return $this;
    }

    /**
     * Get isTemplate.
     *
     * @return integer
     */
    public function getIsTemplate()
    {
        return $this->isTemplate;
    }

    /**
     * Set isConfidential.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setIsConfidential($value)
    {
        $this->isConfidential = $value;
        return $this;
    }

    /**
     * Get isConfidential.
     *
     * @return integer
     */
    public function getIsConfidential()
    {
        return $this->isConfidential;
    }

    /**
     * Set userBonuses.
     *
     * Provides a fluent interface.
     *
     * @param Carerix_Api_Rest_DataType_NSArray|array $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setUserBonuses($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_DataType_NSArray($value);
        }
        $this->userBonuses = $value;
        return $this;
    }

    /**
     * Get userBonuses.
     *
     * @return Carerix_Api_Rest_DataType_NSArray|array
     */
    public function getUserBonuses()
    {
        return $this->userBonuses;
    }

    /**
     * Set invoiceCompanyName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceCompanyName($value)
    {
        $this->invoiceCompanyName = $value;
        return $this;
    }

    /**
     * Get invoiceCompanyName.
     *
     * @return string
     */
    public function getInvoiceCompanyName()
    {
        return $this->invoiceCompanyName;
    }

    /**
     * Set matches.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setMatches($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->matches = $values;
        return $this;
    }

    /**
     * Get matches.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Match
     */
    public function getMatches($index = null)
    {
        if($index !== null) {
            return $this->matches[$index];
        }
        return $this->matches;
    }

    /**
     * Set toUser.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToUser($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toUser = $value;
        return $this;
    }

    /**
     * Get toUser.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToUser()
    {
        return $this->toUser;
    }

    /**
     * Set createdBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setCreatedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->createdBy = $value;
        return $this;
    }

    /**
     * Get createdBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set modifiedBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setModifiedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->modifiedBy = $value;
        return $this;
    }

    /**
     * Get modifiedBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getModifiedBy()
    {
        return $this->modifiedBy;
    }

    /**
     * Set owner.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setOwner($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->owner = $value;
        return $this;
    }

    /**
     * Get owner.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Set attachments.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setAttachments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->attachments = $values;
        return $this;
    }

    /**
     * Get attachments.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Attachment
     */
    public function getAttachments($index = null)
    {
        if($index !== null) {
            return $this->attachments[$index];
        }
        return $this->attachments;
    }

    /**
     * Set publications.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setPublications($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->publications = $values;
        return $this;
    }

    /**
     * Get publications.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Publication
     */
    public function getPublications($index = null)
    {
        if($index !== null) {
            return $this->publications[$index];
        }
        return $this->publications;
    }

    /**
     * Set toStatusNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToStatusNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toStatusNode = $value;
        return $this;
    }

    /**
     * Get toStatusNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToStatusNode()
    {
        return $this->toStatusNode;
    }

    /**
     * Set toSalaryPeriodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToSalaryPeriodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSalaryPeriodNode = $value;
        return $this;
    }

    /**
     * Get toSalaryPeriodNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSalaryPeriodNode()
    {
        return $this->toSalaryPeriodNode;
    }

    /**
     * Set toExperienceLevelNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToExperienceLevelNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toExperienceLevelNode = $value;
        return $this;
    }

    /**
     * Get toExperienceLevelNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToExperienceLevelNode()
    {
        return $this->toExperienceLevelNode;
    }

    /**
     * Set toProvince1Node.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToProvince1Node($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toProvince1Node = $value;
        return $this;
    }

    /**
     * Get toProvince1Node.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToProvince1Node()
    {
        return $this->toProvince1Node;
    }

    /**
     * Set toProductNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToProductNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toProductNode = $value;
        return $this;
    }

    /**
     * Get toProductNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToProductNode()
    {
        return $this->toProductNode;
    }

    /**
     * Set toProductTypeNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToProductTypeNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toProductTypeNode = $value;
        return $this;
    }

    /**
     * Get toProductTypeNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToProductTypeNode()
    {
        return $this->toProductTypeNode;
    }

    /**
     * Set educations.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setEducations($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->educations = $values;
        return $this;
    }

    /**
     * Get educations.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Vacancy_Education
     */
    public function getEducations($index = null)
    {
        if($index !== null) {
            return $this->educations[$index];
        }
        return $this->educations;
    }

    /**
     * Set toVacancyHolder.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToVacancyHolder($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toVacancyHolder = $value;
        return $this;
    }

    /**
     * Get toVacancyHolder.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToVacancyHolder()
    {
        return $this->toVacancyHolder;
    }

    /**
     * Set toFunctionLevel1.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToFunctionLevel1($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toFunctionLevel1 = $value;
        return $this;
    }

    /**
     * Get toFunctionLevel1.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToFunctionLevel1()
    {
        return $this->toFunctionLevel1;
    }

    /**
     * Set toFunctionLevel2.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToFunctionLevel2($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toFunctionLevel2 = $value;
        return $this;
    }

    /**
     * Get toFunctionLevel2.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToFunctionLevel2()
    {
        return $this->toFunctionLevel2;
    }

    /**
     * Set toContractTypeNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToContractTypeNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toContractTypeNode = $value;
        return $this;
    }

    /**
     * Get toContractTypeNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToContractTypeNode()
    {
        return $this->toContractTypeNode;
    }

    /**
     * Set toDriverLicenceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToDriverLicenceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toDriverLicenceNode = $value;
        return $this;
    }

    /**
     * Get toDriverLicenceNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToDriverLicenceNode()
    {
        return $this->toDriverLicenceNode;
    }

    /**
     * Set toSignAuthority.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToSignAuthority($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toSignAuthority = $value;
        return $this;
    }

    /**
     * Get toSignAuthority.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToSignAuthority()
    {
        return $this->toSignAuthority;
    }

    /**
     * Set trainings.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setTrainings($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->trainings = $values;
        return $this;
    }

    /**
     * Get trainings.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Vacancy_Training
     */
    public function getTrainings($index = null)
    {
        if($index !== null) {
            return $this->trainings[$index];
        }
        return $this->trainings;
    }

    /**
     * Set toFunctionTypeNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToFunctionTypeNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toFunctionTypeNode = $value;
        return $this;
    }

    /**
     * Get toFunctionTypeNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToFunctionTypeNode()
    {
        return $this->toFunctionTypeNode;
    }

    /**
     * Set toCountry1Node.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToCountry1Node($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCountry1Node = $value;
        return $this;
    }

    /**
     * Get toCountry1Node.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCountry1Node()
    {
        return $this->toCountry1Node;
    }

    /**
     * Set toSalaryCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToSalaryCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSalaryCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toSalaryCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSalaryCurrencyNode()
    {
        return $this->toSalaryCurrencyNode;
    }

    /**
     * Set toWorkUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToWorkUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toWorkUnitNode = $value;
        return $this;
    }

    /**
     * Get toWorkUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToWorkUnitNode()
    {
        return $this->toWorkUnitNode;
    }

    /**
     * Set toRotationOnUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToRotationOnUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toRotationOnUnitNode = $value;
        return $this;
    }

    /**
     * Get toRotationOnUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToRotationOnUnitNode()
    {
        return $this->toRotationOnUnitNode;
    }

    /**
     * Set toRotationOffUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToRotationOffUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toRotationOffUnitNode = $value;
        return $this;
    }

    /**
     * Get toRotationOffUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToRotationOffUnitNode()
    {
        return $this->toRotationOffUnitNode;
    }

    /**
     * Set toCompetitor.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToCompetitor($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->toCompetitor = $value;
        return $this;
    }

    /**
     * Get toCompetitor.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getToCompetitor()
    {
        return $this->toCompetitor;
    }

    /**
     * Set toResultNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToResultNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toResultNode = $value;
        return $this;
    }

    /**
     * Get toResultNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToResultNode()
    {
        return $this->toResultNode;
    }

    /**
     * Set toEstimatedAmountCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToEstimatedAmountCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toEstimatedAmountCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toEstimatedAmountCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToEstimatedAmountCurrencyNode()
    {
        return $this->toEstimatedAmountCurrencyNode;
    }

    /**
     * Set toRealizedAmountCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToRealizedAmountCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toRealizedAmountCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toRealizedAmountCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToRealizedAmountCurrencyNode()
    {
        return $this->toRealizedAmountCurrencyNode;
    }

    /**
     * Set toInvoiceCountryNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToInvoiceCountryNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceCountryNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceCountryNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceCountryNode()
    {
        return $this->toInvoiceCountryNode;
    }

    /**
     * Set toInvoiceProvinceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToInvoiceProvinceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceProvinceNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceProvinceNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceProvinceNode()
    {
        return $this->toInvoiceProvinceNode;
    }

    /**
     * Set toSalaryScaleCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToSalaryScaleCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSalaryScaleCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toSalaryScaleCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSalaryScaleCurrencyNode()
    {
        return $this->toSalaryScaleCurrencyNode;
    }

    /**
     * Set toSalaryScaleNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToSalaryScaleNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSalaryScaleNode = $value;
        return $this;
    }

    /**
     * Get toSalaryScaleNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSalaryScaleNode()
    {
        return $this->toSalaryScaleNode;
    }

    /**
     * Set toWorkCountryNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToWorkCountryNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toWorkCountryNode = $value;
        return $this;
    }

    /**
     * Get toWorkCountryNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToWorkCountryNode()
    {
        return $this->toWorkCountryNode;
    }

    /**
     * Set toWorkLevelNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToWorkLevelNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toWorkLevelNode = $value;
        return $this;
    }

    /**
     * Get toWorkLevelNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToWorkLevelNode()
    {
        return $this->toWorkLevelNode;
    }

    /**
     * Set toCompany.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToCompany($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->toCompany = $value;
        return $this;
    }

    /**
     * Get toCompany.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getToCompany()
    {
        return $this->toCompany;
    }

    /**
     * Set toSourceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToSourceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toSourceNode = $value;
        return $this;
    }

    /**
     * Get toSourceNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToSourceNode()
    {
        return $this->toSourceNode;
    }

    /**
     * Set jobs.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setJobs($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->jobs = $values;
        return $this;
    }

    /**
     * Get jobs.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Job
     */
    public function getJobs($index = null)
    {
        if($index !== null) {
            return $this->jobs[$index];
        }
        return $this->jobs;
    }

    /**
     * Set toLevel3User.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToLevel3User($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toLevel3User = $value;
        return $this;
    }

    /**
     * Get toLevel3User.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToLevel3User()
    {
        return $this->toLevel3User;
    }

    /**
     * Set toLevel3Company.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToLevel3Company($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->toLevel3Company = $value;
        return $this;
    }

    /**
     * Get toLevel3Company.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getToLevel3Company()
    {
        return $this->toLevel3Company;
    }

    /**
     * Set toLevel2Company.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToLevel2Company($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->toLevel2Company = $value;
        return $this;
    }

    /**
     * Get toLevel2Company.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getToLevel2Company()
    {
        return $this->toLevel2Company;
    }

    /**
     * Set toLevel2User.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToLevel2User($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toLevel2User = $value;
        return $this;
    }

    /**
     * Get toLevel2User.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToLevel2User()
    {
        return $this->toLevel2User;
    }

    /**
     * Set broughtInBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setBroughtInBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->broughtInBy = $value;
        return $this;
    }

    /**
     * Get broughtInBy.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getBroughtInBy()
    {
        return $this->broughtInBy;
    }

    /**
     * Set attributeChanges.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setAttributeChanges($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->attributeChanges = $values;
        return $this;
    }

    /**
     * Get attributeChanges.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Attribute_Change
     */
    public function getAttributeChanges($index = null)
    {
        if($index !== null) {
            return $this->attributeChanges[$index];
        }
        return $this->attributeChanges;
    }

    /**
     * Set toTaxRateNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToTaxRateNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toTaxRateNode = $value;
        return $this;
    }

    /**
     * Get toTaxRateNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToTaxRateNode()
    {
        return $this->toTaxRateNode;
    }

    /**
     * Set toPaymentPeriodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToPaymentPeriodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPaymentPeriodNode = $value;
        return $this;
    }

    /**
     * Get toPaymentPeriodNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPaymentPeriodNode()
    {
        return $this->toPaymentPeriodNode;
    }

    /**
     * Set invoiceLines.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setInvoiceLines($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->invoiceLines = $values;
        return $this;
    }

    /**
     * Get invoiceLines.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Invoice_Line
     */
    public function getInvoiceLines($index = null)
    {
        if($index !== null) {
            return $this->invoiceLines[$index];
        }
        return $this->invoiceLines;
    }

    /**
     * Set toCountry2Node.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToCountry2Node($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCountry2Node = $value;
        return $this;
    }

    /**
     * Get toCountry2Node.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCountry2Node()
    {
        return $this->toCountry2Node;
    }

    /**
     * Set toCountry3Node.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToCountry3Node($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCountry3Node = $value;
        return $this;
    }

    /**
     * Get toCountry3Node.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCountry3Node()
    {
        return $this->toCountry3Node;
    }

    /**
     * Set toProvince2Node.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToProvince2Node($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toProvince2Node = $value;
        return $this;
    }

    /**
     * Get toProvince2Node.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToProvince2Node()
    {
        return $this->toProvince2Node;
    }

    /**
     * Set toProvince3Node.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToProvince3Node($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toProvince3Node = $value;
        return $this;
    }

    /**
     * Get toProvince3Node.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToProvince3Node()
    {
        return $this->toProvince3Node;
    }

    /**
     * Set toInvoiceUser.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToInvoiceUser($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User($value); 
        }                 
        $this->toInvoiceUser = $value;
        return $this;
    }

    /**
     * Get toInvoiceUser.
     *
     * @return Carerix_Api_Rest_Entity_User
     */
    public function getToInvoiceUser()
    {
        return $this->toInvoiceUser;
    }

    /**
     * Set toInvoiceCompany.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Company $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToInvoiceCompany($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Company($value); 
        }                 
        $this->toInvoiceCompany = $value;
        return $this;
    }

    /**
     * Get toInvoiceCompany.
     *
     * @return Carerix_Api_Rest_Entity_Company
     */
    public function getToInvoiceCompany()
    {
        return $this->toInvoiceCompany;
    }

    /**
     * Set toVacancyTypeNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToVacancyTypeNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toVacancyTypeNode = $value;
        return $this;
    }

    /**
     * Get toVacancyTypeNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToVacancyTypeNode()
    {
        return $this->toVacancyTypeNode;
    }

    /**
     * Set toInvoiceHandlingNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToInvoiceHandlingNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceHandlingNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceHandlingNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceHandlingNode()
    {
        return $this->toInvoiceHandlingNode;
    }

    /**
     * Set toInvoiceLineLabelNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToInvoiceLineLabelNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toInvoiceLineLabelNode = $value;
        return $this;
    }

    /**
     * Get toInvoiceLineLabelNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToInvoiceLineLabelNode()
    {
        return $this->toInvoiceLineLabelNode;
    }

    /**
     * Set toPaymentPeriodStartDateNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToPaymentPeriodStartDateNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toPaymentPeriodStartDateNode = $value;
        return $this;
    }

    /**
     * Get toPaymentPeriodStartDateNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToPaymentPeriodStartDateNode()
    {
        return $this->toPaymentPeriodStartDateNode;
    }

    /**
     * Set toCreditMethodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToCreditMethodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCreditMethodNode = $value;
        return $this;
    }

    /**
     * Get toCreditMethodNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCreditMethodNode()
    {
        return $this->toCreditMethodNode;
    }

    /**
     * Set groupNodes.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setGroupNodes($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->groupNodes = $values;
        return $this;
    }

    /**
     * Get groupNodes.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Data_Node
     */
    public function getGroupNodes($index = null)
    {
        if($index !== null) {
            return $this->groupNodes[$index];
        }
        return $this->groupNodes;
    }

    /**
     * Set toCategoryNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToCategoryNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toCategoryNode = $value;
        return $this;
    }

    /**
     * Get toCategoryNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToCategoryNode()
    {
        return $this->toCategoryNode;
    }

    /**
     * Set vacancyUsers.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setVacancyUsers($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values); 
        } 
        $this->vacancyUsers = $values;
        return $this;
    }

    /**
     * Get vacancyUsers.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_Vacancy_User
     */
    public function getVacancyUsers($index = null)
    {
        if($index !== null) {
            return $this->vacancyUsers[$index];
        }
        return $this->vacancyUsers;
    }

    /**
     * Set toProjectNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Data_Node $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToProjectNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Data_Node($value); 
        }                 
        $this->toProjectNode = $value;
        return $this;
    }

    /**
     * Get toProjectNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToProjectNode()
    {
        return $this->toProjectNode;
    }

    /**
     * Set toConfidentialUserRole.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_User_Role $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setToConfidentialUserRole($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_User_Role($value); 
        }                 
        $this->toConfidentialUserRole = $value;
        return $this;
    }

    /**
     * Get toConfidentialUserRole.
     *
     * @return Carerix_Api_Rest_Entity_User_Role
     */
    public function getToConfidentialUserRole()
    {
        return $this->toConfidentialUserRole;
    }

    /**
     * Set agency.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_Agency $value
     * @return Carerix_Api_Rest_Entity_Abstract_Vacancy
     */
    public function setAgency($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_Agency($value); 
        }                 
        $this->agency = $value;
        return $this;
    }

    /**
     * Get agency.
     *
     * @return Carerix_Api_Rest_Entity_Agency
     */
    public function getAgency()
    {
        return $this->agency;
    }


}