<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights
 * reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @build Thu, 21 Jul 2011 11:13:35 +0300
 */
class Carerix_Api_Rest_Entity_Publication extends Carerix_Api_Rest_Entity_Abstract_Publication
{
    /**
     * Get a list of published jobs. 
     * 
     * @param array $parameters [optional]
     * @param integer $hydrate [optional] hydration method
     * 
     * @return Carerix_Api_Rest_Collection
     * 
     * @see http://development.wiki.carerix.com/index.php/Cxrest_API_methods#GET_publication.2Flist-by
     * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
     */        
    public static function listBy($parameters = null, $hydrate = null)
    {

        $args = func_get_args();
        switch(count($args)) {
            case 1:
                   if(!is_array($args[0])) {
                    $parameters = array();
                    $hydrate = $args[0];
                }            
            break;
        }
                
        // get_called_class_static cannot detect the class    
//        return self::findAll('list-by', $parameters, $hydrate);
        return Carerix_Api_Rest_Entity_Publication::findAll('list-by', $parameters, $hydrate);
    }

}