<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2011 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2011-09-12 08:50:33Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights
 * reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @build Thu, 21 Jul 2011 11:13:38 +0300
 */
class Carerix_Api_Rest_Entity_To_Do extends Carerix_Api_Rest_Entity_Abstract_To_Do
{
   /**
     * @var integer
     * @type NSNumber
     * @length N/A
     * @required true
     * @access private
     */
    public $isVisibleForAllUsers = null;    

   /**
     * @var integer
     * @type NSNumber
     * @length N/A
     * @required true
     * @access private
     */
    public $isAllDay = null;    

     /**
     * @var string
     * @type NSCalendarDate
     * @length N/A
     * @required false
     * @access private
     */
    public $startDate;

     /**
     * @var string
     * @type NSCalendarDate
     * @length N/A
     * @required false
     * @access private
     */
    public $endDate;
    
    /**
     * Set isVisibleForAllUsers.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_To_Do
     */
    public function setIsVisibleForAllUsers($value)
    {
        $this->isVisibleForAllUsers = $value;
        return $this;
    }

    /**
     * Get isVisibleForAllUsers.
     *
     * @return integer
     */
    public function getIsVisibleForAllUsers()
    {
        return $this->isVisibleForAllUsers;
    }
    
    /**
     * Gets startDate
     *
     * @return string
     */
    public function getStartDate() 
    {
        return $this->startDate;
    }
    
    /**
     * Sets startDate
     *
     * Provides a fluent interface.
     *
     * @param string $startDate startDate
     * @return Carerix_Api_Rest_Entity_Abstract_To_Do
     */
    public function setStartDate($startDate) 
    {
        $this->startDate = $startDate;
        return $this;
    }

    /**
     * Gets endDate
     *
     * @return string
     */
    public function getEndDate() 
    {
        return $this->endDate;
    }
    
    /**
     * Sets endDate
     *
     * Provides a fluent interface.
     *
     * @param string $endDate endDate
     * @return Carerix_Api_Rest_Entity_Abstract_To_Do
     */
    public function setEndDate($endDate) 
    {
        $this->endDate = $endDate;
        return $this;
    }
    
    /**
     * Set isAllDay.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_To_Do
     */
    public function setIsAllDay($value)
    {
        $this->isAllDay = $value;
        return $this;
    }

    /**
     * Get isAllDay.
     *
     * @return integer
     */
    public function getIsAllDay()
    {
        return $this->isAllDay;
    }
    
    
    /**
     * Entity configuration.
     * Patch for non-standard identifier key. Expected toDoID. Actual todoID.
     * 
     * @param Carerix_Api_Rest_EntityConfiguration $entityConfiguration
     */    
    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("todoID");
    }    
}